/******* Woodman Docker for CorelDraw Copyright (c) by DukereD 2023 mailto: laserman@tut.by *******/
version = '3.01.55';
var glOptim = false;
var host = window.external.Application;
var CR = chr(10)+chr(13);
defdoc();
var master = null;
var mastercont = null;
var template_add_btn = null;
var domove = false;
var tg60 = 1.73205080757;
if(vbRead('lang')===undefined){
	vbWrite('lang','ru');
	vbWrite('cat_settings','true');
}
var cLang = vbRead('lang');
//cLang="ru";
var clrs = [];
clrs['yellow']=['FFE','FFF'];
clrs['yellow dark']=['FFD','FFE'];
clrs['red']=['FEF','FFF'];
clrs['blue']=['EFF','FFF'];
clrs['white']=['EEE','FFF'];
clrs['gray1']=['DDD','EEE'];
clrs['gray2']=['BBB','CCC'];
clrs['gray3']=[999,'AAA'];
clrs['gray4']=[777,999];
clrs['gray5']=[555,777];
clrs['dark']=[444,555];

if(vbRead('bgcolor')===undefined) vbWrite('bgcolor','white');
var cColor = (!clrs[vbRead('bgcolor')]) ? clrs['white'] : clrs[vbRead('bgcolor')];
//var cColor = clrs['white'];
var head  = document.getElementsByTagName('head')[0];

/*
var link  = document.createElement('script');
link.type = 'text/javascript';
link.src = 'langs/ru.js';
head.appendChild(link);
*/

if (cLang!='ru'){
	var link  = document.createElement('script');
	link.type = 'text/javascript';
	link.src = 'langs/' + cLang + '.js';
	head.appendChild(link);
}
in_main = document.title.substring(0,13)=="Woodman Panel";

/*HTML interface functions*/

function do_langs_list(){
	var langs = [];
	langs['ru']='Русский';
	langs['en']='English';
	langs['de']='Deutch';
	langs['es']='Español';
	langs['ua']='Український';
	langs['pl']='Polski';
	langs['bg']='Bulgarian';
	langs['kz']='Казахский';
	langs['uz']='Узбекский';
	langs['cn']='中文';

	for(var key in langs){
		sel = (cLang == key) ? ' SELECTED' : '';
		document.write('<option value="'+key+'"'+sel+'>'+langs[key]+'</option>');
	}
}

function do_setcolor_list(){
	for(var key in clrs){
		sel = (cColor[0] == clrs[key][0]) ? ' SELECTED' : '';
		document.write('<option value="'+key+'"'+sel+' style="background:#'+clrs[key][0]+'">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>');
	}
}

function do_contur_btns(){
	var cols=vall(vbRead('val_set_conturs'),false);
	if(!cols) cols = 7;
	if (cols<3) cols=3;
	if (cols>10)cols=10;
	colwi=(91/cols)+"%";
	for(var i=1;i<=cols;i++) document.write('<img src="img/rou.png" style="width:'+colwi+'" onclick="make_round('+i+')" value="rou" id="cont_round_'+i+'" /> ');
	for(var i=1;i<=cols;i++) document.write('<img src="img/cont_out.png" style="width:'+colwi+'" onclick="make_contur(1,'+i+')" value="out" id="cont_out_'+i+'" /> ');
	for(var i=1;i<=cols;i++) document.write('<input type="text" id="val_cont_'+i+'" style="width:'+colwi+'" value="'+(getRandom(10,0.1,1))+'" onChange="do_save(this)" /> ');
	for(var i=1;i<=cols;i++) document.write('<img src="img/cont_in.png"  style="width:'+colwi+'" onclick="make_contur(0,'+i+')" value="in" id="cont_in_'+i+'" /> ');
}

function do_fefco_list(){
	var fldr = vbReadFolder('fefco');
	var curf = vbRead('fefco_list');
	for(var key in fldr){
		file = fldr[key].substring(0,4);
		sel = (file == curf) ? ' SELECTED' : '';
		document.write('<option value="'+file+'"'+sel+'>'+file+'</option>');
	}
}

function do_add_list(){
	var cur = vbRead('add_lists');
	var list = vbRead('val_add_lists');
	if (list!=undefined){
		sep = list.split(":");
		for(var i=0;i<sep.length;i++){
			if (sep[i].length>3){
				csep = sep[i].split("x");
				val = (csep[0]) +"x"+ (csep[1]);
				sel = (cur == val) ? ' SELECTED' : '';
				document.write('<option value="'+val+'"'+sel+'>' + val +'</option>');
			}
		}
	}
}

function do_templates_list(){
	var cur = vbRead('template_list');
	var path = vbRead('val_template_path');
	var templs = vbTemplList(path, lang['text_templ_notempl_title'], lang['text_templ_notempl_msg']);
	if (cur==undefined) cur = templs[1];
	if (cur!=undefined && templs!=undefined){
		for(var i=1;i<templs.length;i++){
			val = templs[i];
			if (val.length>1){
				sel = (cur == val) ? ' SELECTED' : '';
				document.write('<option value="'+val+'"'+sel+'>' + val +'</option>');
			}
		}
	}
}

function do_template(mode, pic){
	if (defdoc()){
		shft = Shift();
	//"Открыть папку текущей категории  / +Shift Добавить новую категорию / +Ctrl удалить текущую категорию / +Alt задать путь к папке с категориями.";
		path = (val_template_path.value.length>3) ? val_template_path.value : "";
		path_cat = path + template_list.value + "\\";
		if (mode == "cat"){
			templ_add = "";
			switch (shft){
				case 0: vbOpenFolder(path_cat); break;
				case 1: templ_add = vbTemplCatAdd(path, lang['text_templ_add_title'], lang['text_templ_add_msg'], lang['text_templ_add_msgexist']); break;
				case 2: templ_add = vbTemplCatDel(path, template_list.value, lang['text_templ_del_title'], lang['text_templ_del_msg']); break;
				case 4: templ_add = vbTemplPath(path, lang['text_templ_set_title']);
					if (templ_add.length>3) val_template_path.value = templ_add;
					do_save(val_template_path);
					break;
			}
			if (templ_add.length>1) {
				vbWrite("template_list",templ_add);
				location.reload(); 
			}
		}else if(mode == "list"){
			do_save(template_list);
			files = vbTemplFiles(path_cat);
			out = "";
			for(var i=0;i<files.length;i++){
				pic = files[i];
				if (pic.length>3){
					fname = pic.substring(0,pic.length-4).split("_");
					tit = (fname.length>2) ? fname[2] : "";
					out += '<img src="'+path_cat+pic+'" class="template_pic" onClick="do_template(\'insert\',\''+pic+'\')" alt="'+tit+'" />';
				}
			}
			//alert(templates_div.innerHTML.length);
			if (out.length>10) templates_div.innerHTML = out; else if (templates_div.innerHTML.length>170) templates_div.innerHTML = template_add_btn;
		}else if(mode=="insert" || mode=="add_new"){
			fname = (pic!=undefined) ? pic.substring(0,pic.length-4) : "nonono";
			os = get_OS(false,false);
			if (shft==1 || mode=="add_new"){
				vbTemplFileAdd(path_cat);
				do_template("list");
			}else if (shft==2){
				if (vbTemplFileDel(path_cat, fname, lang['text_templ_delpic_title'], lang['text_templ_delpic_msg'])) do_template("list");
			}else{
				do_begin("insert template", true, glOptim);
				pst = vbImportFile(path_cat+fname + ".cdr");
				if (os.Shapes.Count > 0){
					for (var i=1;i<=os.Shapes.Count;i++){
						s  = os.Shapes(i);
						//koef = s.SizeHeight / pst.SizeHeight;
						//wi = pst.SizeWidth * koef;
						//if (wi > s.SizeWidth) pst.SetSize (s.SizeWidth,0); else pst.SetSize (0, s.SizeHeight);
						moveC(pst, s.centerX, s.centerY);
						pst.SetSize (s.SizeWidth, s.SizeHeight);
						if (i < os.Shapes.Count) pst = pst.Duplicate();
						if (shft != 4) s.Delete();
					}
				}else{
					moveC(pst);
				}
				host.ActiveDocument.ClearSelection();
				do_end(true);
			}
		}
	}
}

function do_color_list(){
	var colors = ["000","666","999","FFF","F00","F60","FF0","0F0","0FF","00F","90C","F0F"];
	mc = colors.length;
	var cur_color = vbRead('gapcolor');
	for(var i=0;i<colors.length;i++){
		color = colors[i];
		sel = (color == cur_color) ? ' SELECTED' : '';
		document.write('<option value="'+color+'"'+sel+' style="background:#'+color+'">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>');
	}
}

function OnLoad(){
	for(var key in hint){
		if(key.substring(0,5)=="cont_"){
			for(var i=1;i<20;i++){
				var but = document.getElementById(key+i);
				if(but) but.title=hint[key];
			}
		}else{
			var but = document.getElementById(key);
			if(but) but.title=hint[key];
		}
	}
	var elems = document.getElementsByTagName('label');
	for (var i = 0; i < elems.length; i++){
		var el = elems[i];
		if(hint[el.htmlFor]) el.title=hint[el.htmlFor];
	}
	
	for(var key in btns){
		if(key.substring(0,5)=="cont_"){
			for(var i=1;i<20;i++){
				var but = document.getElementById(key+i);
				if(but) but.value=btns[key];
			}
		}else{
			var but = document.getElementById(key);
			if(but){
				if(btns[key].substring(0,4)=="src:"){
					but.style.backgroundImage= "url('"+btns[key].substring(4)+"')";
					but.value="";
				}else{
					but.value=btns[key];
				}
			}
		}
	}
		
	if(vbRead('cats')){
		cats = vbRead('cats').split("/");
		if (cats.length>3){
			for (var i = cats.length-1; i >= 0 ; i--){
				prv = cats[i];
				nxt = cats[i+1];
				ids = prv.substring(6);
				el_nxt1 = document.getElementById(prv);
				el_nxt2 = document.getElementById(ids);
				el_prv = document.getElementById(nxt);
				document.body.insertBefore(el_nxt1,el_prv);		
				document.body.insertBefore(el_nxt2,el_prv);		
			}	
		}
	}
	
	if(vbRead('ch_set_titles')=="false" && in_main){
		var elems = document.getElementsByTagName('p');
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if(el.id.substring(0,10)=="title_cat_"){
				var img  = document.createElement('span');
				ids = el.id.substring(6);
				img.innerHTML = '<img src="img/'+el.id+'.png" oncontextmenu="return show_help(this)" id="img_'+el.id+'" class="float_but_title" onClick="ShowCat(\''+ids+'\')" lang="'+hint[el.id]+'" title="'+lang[el.id]+'"/>';
				all_tabs.appendChild(img);
			}
		}
	}
	
	document.body.style.background = "#" + cColor[0];
	if (cColor[0]>0 && cColor[0]<888){document.body.style.color="EEE";}

	var elems = document.getElementsByTagName('div');
	var cnt = 0;
	for (var i = 0; i < elems.length; i++){
		var el = elems[i];
		if(el.id.substring(0,4)=="cat_"){
			colo = (cnt % 2 == 0) ? cColor[0] : cColor[1];
			var tit = document.getElementById('title_' + el.id);
			if (!tit) var tit = document.getElementById('tit_' + el.id);
			el.style.background =  "#" + colo;
			if (tit){
				tit.style.background = "#" + colo;
				cnt++;
			}
		}
	}
	do_read();
	if(in_main){
		template_add_btn = templates_div.innerHTML;
		do_template("list");
	}
	//window.external.Application.InitializeVBA();
//	RegisterEvent();      // tells draw to notify us when the selection changes.
//	OnSelectionChange();  // initialize the dialog
	tm = vbRead('stat_time');
	var now = new Date();
	if (tm==undefined) tm = [77,77]; else tm = tm.split(":");
	if( Math.abs(now.getHours()-tm[1])>4 || now.getDate() != tm[0]){
		vbStatSend(version);
		vbWrite('stat_time',now.getDate() + ":" + now.getHours());
	}
}

function show_title(tit){
	if(vbRead('ch_set_titles')!="false" || !in_main){
		document.write(lang[tit]);
		if(vbRead('ch_set_titles_move')=="true"){
			document.write('<span style="position:absolute; right:4px;"><input type="button" style="width:20px" onclick="do_move(\''+tit+'\',\'up\')" value="&and;" /><input type="button" style="width:20px" onclick="do_move(\''+tit+'\',\'dn\')" value="&or;" /></span>');
		}
	}
}

function cat_state(state, shft){
	if(shft === undefined) shft = Shift();
	var stval = document.getElementById('val_state_' + state);
	var states = [];
	if(stval){
		if(shft==1){
			var conf = true;
			if (state>0 && stval.value.length>2) if (!confirm(lang['text_state_overwrite'])) conf = false;
			if (conf){
				var elems = document.getElementsByTagName('p');
				for (var i = 0; i < elems.length; i++){
					var el = elems[i];
					if(el.id.substring(0,10)=="title_cat_"){
						var ids = el.id.substring(6);
						var cat = document.getElementById(ids);
						if(cat) if (cat.style.display != "none") states.push(ids);
					}
				}
				stval.value = states.join(":");
				do_save(stval);
				if (state>0) cat_state(state, 0);
			}
		}else{
			last_val = vall(state_last.value,false,0);
			if (last_val==state){
				var stval = document.getElementById('val_state_last');
				state_last.value = 0;
			}else{
				if (last_val<1) cat_state("last", 1);
				state_last.value = state;
			}
			if(stval.value.length>0){
				var states = stval.value.split(":");
				var elems = document.getElementsByTagName('p');
				for (var i = 0; i < elems.length; i++){
					var el = elems[i];
					if(el.id.substring(0,10)=="title_cat_"){
						var ids = el.id.substring(6);
						ShowCat(ids, inArray(ids, states));
					}
				}
			}
		}
	}
}

function showhide(id, save){
	if(save === undefined) save = false;
	cat = document.getElementById(id);
	cat.style.display = (cat.style.display == "block") ? "none" : "block";
	if (save) do_save(cat);
}
function ShowCat(cat_id, show){
	if(show === undefined) show = "def";
	if (!domove){
		var shft = Shift();
		var show_titles = vbRead('ch_set_titles');

		var titcat = document.getElementById("title_" + cat_id);
		var cat = document.getElementById(cat_id);
		var img = document.getElementById("img_title_" + cat_id);
		if(show=="def")	show = (cat.style.display == "block") ? false : true;
		if (!show && shft!=4){
			cat.style.display = "none";
			if(titcat){
				if(show_titles=="false" && in_main){
					img.style.filter  = 'alpha(opacity=30)';
					titcat.style.padding="0";
				}else{
					titcat.style.paddingBottom="2px";
				}
			}
				//border-top: solid 1px;
			//titcat.style.borderBottom = "solid 1px";
			cat.style.paddingBottom="0";
		}else{
			cat.style.display = "block";
			if (titcat){
				if(show_titles=="false" && in_main){
					img.style.filter  = 'alpha(opacity=100)';
					titcat.style.padding="0";
					cat.style.paddingBottom="3px";
					cat.style.borderBottom="solid 1px black";
				}else{
					titcat.style.padding="2px";
					cat.style.paddingBottom="6px";
				}
			}
		}
		do_save(cat);
		
		var elems = document.getElementsByTagName('p');
		var states = [];
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if (el){
				if(el.id.substring(0,10)=="title_cat_"){
					ids = el.id.substring(6);
					var cat = document.getElementById(ids);
					if(cat){
						if (cat.style.display != "none") states.push(ids);
						if (shft==4 && ids!=cat_id){
							cat.style.display = "none";
							if(show_titles=="false" && in_main){
								img = document.getElementById("img_title_" + ids);
								img.style.filter  = 'alpha(opacity=30)';
							}
							do_save(cat);
						}
					}
				}
			}
		}	
		if(in_main){
			stv = states.join(":");	
			if(stv.length==0){
				ShowCat(cat_id);
			}else{
				isState = 0;
				for(var i=1;i<4;i++){
					var btn = document.getElementById('btn_state_'+i);
					var sti = document.getElementById('val_state_'+i).value;
					if (sti==stv){
						btn.style.backgroundColor = "#999";
						isState = i;
					}else{
						btn.style.backgroundColor = "";
					}
				}
				state_last.value = isState;
			}
		}
	}
	domove = false;
}


function do_move(tit,dir){
	if (tit=="reset"){
		if (confirm(lang['cats_reset_confirm'])){
			vbWrite('cats',"1/2");
			location.reload();
		}
	}else{
		domove = true;
		var elems = document.getElementsByTagName('p');
		prv = "";
		nxt = "";
		fnd = false;
		ids = tit.substring(6);
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if(el.id.substring(0,10)=="title_cat_"){
				if (fnd) {nxt = el.id; break;}
				if(el.id==tit) fnd = true;
				if (!fnd) prv = el.id;
			}
		}
		
		el_prv = false;
		if(dir=="up" && prv.length>2){
			el_nxt1 = document.getElementById(tit);
			el_nxt2 = document.getElementById(ids);
			el_prv = document.getElementById(prv);
		}
		if(dir=="dn" && nxt.length>2){
			el_nxt1 = document.getElementById(nxt);
			nids = nxt.substring(6);
			el_nxt2 = document.getElementById(nids);
			el_prv = document.getElementById(tit);
		}

		if(el_prv){
			document.body.insertBefore(el_nxt1,el_prv);		
			document.body.insertBefore(el_nxt2,el_prv);		
		}
		
		var cats = [];
		for (var i = 0; i < elems.length; i++){
			var el = elems[i];
			if(el.id.substring(0,10)=="title_cat_"){
				cats.push(el.id);
			}
		}
		all_cats = cats.join("/");
		vbWrite('cats',all_cats);
	}
}

function do_events(bid){
	//warn("");
}

function do_save(el,min,max){
	if(min === undefined) min = false;
	if(max === undefined) max = false;
	key = el.id;
	var val = null;
	if (key.substring(0,4)=="cat_"){
		val = (el.style.display == "block") ? true : false;
	}else if(key.substring(0,3)=="ch_"){
		val = el.checked;
	}else{
		val = el.value;
	}		

	if(key.substring(0,6)=="radio_"){
		var elems = document.getElementsByName(el.name);
		for (var i = 0; i < elems.length; i++){
			val = (elems[i].checked) ? "true" : "false";
			vbWrite(elems[i].id,val);
		}		
	}else if(val!=null){
		if (min && max){
			if (val<min) val=min;
			if (val>max) val=max;		
		}
		if(val === true) val = "true";
		if(val === false) val = "false";
		vbWrite(key,val);
	}
	
	if(key=="lang" || key=="bgcolor" || key=="ch_set_titles_move" || key=="ch_set_titles" || key=="val_set_conturs" || key=="val_add_lists"){
		location.reload(); 
	}		
}

function do_read(){
	var elems = document.getElementsByTagName('*');
	for (var i = 0; i < elems.length; i++){
		el = elems[i];
		key = el.id;
		val = vbRead(el.id);
		if (val!=undefined){
			if(val == "true") val = true;
			if(val == "false") val = false;
			if (key.substring(0,4)=="cat_"){
				ShowCat(key,val);
			}else if(key.substring(0,3)=="ch_" || key.substring(0,6)=="radio_"){
				el.checked=val;
			}else if(key.substring(0,4)=="val_"){
				el.value=val;
			}		
  		}
	}		
}

/*Corel functions*/
/*
function RegisterEvent(){
    // tell coreldraw to call OnSelectionChange when the selection changes
	window.external.RegisterEventListener( "SelectionChange", "OnSelectionChange()" );
}
function UnregisterEvent(){
    // if you want to stop listening for the selection change event, call this function
    window.external.UnregisterEventListener( "SelectionChange" );
}
*/

function scan_colors(){
	do_events("button_scan_colors");
	var fcolors = [];
	var ffcolors = [];
	var ocolors = [];
	var effects = [];
	var texts = [];
	col_btns = document.getElementById("scan_colors_buttons");
	col_sel = document.getElementById("button_select_colors");
	shft = Shift();
	var OS = get_OS(false);
	col_btns.innerHTML = '';
	var cnt_all=0;
	for(var i=1;i<OS.Shapes.Count+1;i++){
		s = OS.Shapes(i);
		if(s.type==7) {
			key = 40;
			if (!effects[key]){effects[key] = []; effects[key]['cnt'] = 0;}
			effects[key]['cnt']++;
			effects[key]['title'] = "Groups (" + effects[key]['cnt'] + ")";
			effects[key]['ltr'] = "Groups: " + effects[key]['cnt'] + "";
			cnt_all++;
		}else if(s.type==5){
			cl = get_bitmap_mode(s.Bitmap);
			key = cl['mode'];
			if (!effects[key]){effects[key]=[]; effects[key]['cnt']=0;}
			effects[key]['cnt']++;
			effects[key]['title']=cl['name'] +" (" + effects[key]['cnt'] + ")";
			effects[key]['ltr']=cl['name'].substring(0,8) + ": " + effects[key]['cnt'] + "";
			cnt_all++;
		}else if(s.PowerClip){
			key = 'pwr';
			if (!effects[key]){effects[key]=[]; effects[key]['cnt']=0;}
			effects[key]['cnt']++;
			effects[key]['title']="PowerClip (" + effects[key]['cnt'] + ")";
			effects[key]['ltr']="PwrCl: " + effects[key]['cnt'] + "";
			cnt_all++;
		}else if(isSimpleShape(s) && s.Effects.Count==0){
			if(s.Fill.Type==0){
				if (!fcolors[0]){fcolors[0]=[]; fcolors[0]['cnt']=0;}
				fcolors[0]['cnt']++;
				fcolors[0]['stitle']=lang['text_nofill'] + ": " + fcolors[0]['cnt'];
				fcolors[0]['title']=lang['text_nofill'] + " (" + fcolors[0]['cnt'] + ") ";
				cnt_all++;
			}else if(s.Fill.Type==1){
				cl = get_color_info(s.Fill.UniformColor);
				hex = cl['hex'];
				if (!fcolors[hex]){fcolors[hex]=[]; fcolors[hex]['cnt']=0;}
				fcolors[hex]['cnt']++;
				fcolors[hex]['gray'] = cl['gray'];
				fcolors[hex]['stitle']=cl['hint'] + ": " + fcolors[hex]['cnt'];
				fcolors[hex]['title']=cl['hint'] + " (" + fcolors[hex]['cnt'] + ") " + cl['hex'];
				cnt_all++;
			}else if(s.Fill.Type==2){
				cl = get_color_info(s.Fill.Fountain.Colors, true);
				hex = cl['hex'];
				if (!ffcolors[hex]){ffcolors[hex]=[]; ffcolors[hex]['cnt']=0;}
				ffcolors[hex]['cnt']++;
				ffcolors[hex]['gray'] = cl['gray'];
				ffcolors[hex]['digs'] = cl['digs'];
				ffcolors[hex]['title']=lang['text_ffill'] + " " + cl['hint'] + " (" + ffcolors[hex]['cnt'] + ") " + cl['hex'];
				cnt_all++;
			}
			if(s.Outline.Type==0){
				if (!ocolors[0]){ocolors[0]=[]; ocolors[0]['cnt']=0;}
				ocolors[0]['cnt']++;
				ocolors[0]['stitle']=lang['text_nooutline'] + ": " + ocolors[0]['cnt'];
				ocolors[0]['title']=lang['text_nooutline'] + " (" + ocolors[0]['cnt'] + ") ";
				cnt_all++;
			}else{
				cl = get_color_info(s.Outline.Color);
				hex = cl['hex'];
				if (!ocolors[hex]){ocolors[hex]=[]; ocolors[hex]['cnt']=0;}
				ocolors[hex]['cnt']++;
				ocolors[hex]['stitle']=cl['hint'] + ": " + ocolors[hex]['cnt'];
				ocolors[hex]['title']=cl['hint'] + " (" + ocolors[hex]['cnt'] + ") " + cl['hex'];		
				cnt_all++;
			}
			if (s.Type==6) {
				hex = s.Text.Story.Font;
				if (!texts[hex]) { texts[hex] = []; texts[hex]['cnt'] = 0;}
				texts[hex]['cnt']++;
				fin = hex.indexOf(" ", 4);
				if (fin>8 || fin<0) fin = 8;
				texts[hex]['title'] = hex.substring(0,fin) + ": " + texts[hex]['cnt'];
				texts[hex]['hint'] = hex + " (" + texts[hex]['cnt'] + ")";
				cnt_all++;
			}
		}else if (s.Effects.Count==1){
			ef = get_effect_info(s.Effects(1));
			key = 50 + ef['type'];
			if (!effects[key]){effects[key]=[]; effects[key]['cnt']=0;}
			effects[key]['cnt']++;
			effects[key]['title']=ef['name'] + " (" + effects[key]['cnt'] + ")";
			effects[key]['ltr']=ef['ltr'] + ": " + effects[key]['cnt'] + "";
			cnt_all++;
		}
	}
	if (cnt_all>0) col_sel.disabled=false;
	cnt_all=0;
	i=0;

	for(var key in ocolors){
		ids = "ocolor_" + i;
		styleo = (key!=0) ? "border:solid 3px " + key : "";
		var link  = document.createElement('span');
		if(shft==4 || shft==5){
			stl = "color_btn3";
			cnt = ocolors[key]['stitle'];
		}else{
			stl = "color_btn";
			cnt = ocolors[key]['cnt'];
		}
		link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" style="'+styleo+'" value="'+cnt+'" step="'+cnt+'" title="'+ocolors[key]['title']+'" onClick="select_color('+ids+')" name="outl" src="'+key+'" />';
		col_btns.appendChild(link);
		cnt_all++;
		i++;
	}
	for(var key in fcolors){cnt_all++;}
	btn_cnt = Math.floor(col_btns.offsetWidth/40);
	if(cnt_all>btn_cnt) {col_btns.appendChild(document.createElement('br'));}
	i=0;
	for(var key in fcolors){
		ids = "fcolor_" + i;
		stylef = (key!=0) ? "background-color:" + key + ";" : "";
		if (fcolors[key]['gray']) stylef += "color: " + fcolors[key]['gray'] + ";";
		var link  = document.createElement('span');
		if(shft==4 || shft==5){
			stl = "color_btn3";
			cnt = fcolors[key]['stitle'];
		}else{
			stl = "color_btn";
			cnt = fcolors[key]['cnt'];
		}
		link.innerHTML = '<input type="button" id="'+ids+'" class="'+stl+'" style="'+stylef+'" value="'+cnt+'" step="'+cnt+'" title="'+fcolors[key]['title']+'" onClick="select_color('+ids+')" name="fill" src="'+key+'" />';
		col_btns.appendChild(link);
		i++;
	}

	for(var key in ffcolors){cnt_all+=2;}
	if(cnt_all>btn_cnt) {col_btns.appendChild(document.createElement('hr'));}
	i=0;
	for(var key in ffcolors){
		var ids = "ffcolor_" + i;
		var skey = ffcolors[key]['digs'];
		var numc = skey.length;
	 	stylef = (ffcolors[key]['gray']) ? "color: " + ffcolors[key]['gray'] + ";" : "";
		var link  = document.createElement('span');
		divs = '<div class="table_border">' +
			'<div id="'+ids+'" class="ffill_btn" value="'+ffcolors[key]['cnt']+'" step="'+ffcolors[key]['cnt']+'" title="'+ffcolors[key]['title']+'" onClick="select_color('+ids+')" name="ffill" src="'+key+'" >'+ffcolors[key]['cnt']+'</div>' +
			'<table border="0" cellspacing="0" cellpadding="0" class="color_btn_eff"><tr>';
		for(var di=0;di<numc;di++){
			//stylef = (skey[0]!=0) ? "background-color:" + skey[0] + ";" : "";
			divs += '<td style="background-color: '+skey[di]['hex']+' ;"></td>';
		}
		divs += '</tr></table></div>';
		link.innerHTML = divs;
		if (i==0) link.innerHTML = '' + link.innerHTML;
		col_btns.appendChild(link);
		i++;
	}
	
	for(var key in effects){cnt_all+=2;}
	if(cnt_all>btn_cnt) {col_btns.appendChild(document.createElement('hr'));}
	i=0;
	for(var key in effects){
		ids = "effects_" + i;
		var link  = document.createElement('span');
		link.innerHTML = '<input type="button" id="'+ids+'" class="color_btn_eff" value="'+effects[key]['ltr']+'" step="'+effects[key]['ltr']+'" title="'+effects[key]['title']+'" onClick="select_color('+ids+')" name="effects" src="'+key+'" />';
		if (i==0) link.innerHTML = '' + link.innerHTML;
		col_btns.appendChild(link);
		i++;
	}	
	for(var key in texts){cnt_all+=2;}
	if(cnt_all>btn_cnt) {col_btns.appendChild(document.createElement('hr'));}
	i=0;
	for(var key in texts){
		ids = "texts_" + i;
		var link  = document.createElement('span');
		link.innerHTML = '<input type="button" id="'+ids+'" class="color_btn_eff" value="'+texts[key]['title']+'" step="'+texts[key]['title']+'" title="'+texts[key]['hint']+'" onClick="select_color('+ids+')" name="texts" src="'+key+'" />';
		if (i==0) link.innerHTML = '' + link.innerHTML;
		col_btns.appendChild(link);
		i++;
	}
}

function get_effect_info(effect){
	var ret = [];
	switch (effect.type){
		case 0: 
			var sname = "Blend";
			var ltr = "Blend";
			break;
		case 1: 
			var sname = "Extrude";
			var ltr = "Extrd";
			break;
		case 2: 
			var sname = "Envelope";
			var ltr = "Envel";
			break;
		case 3: 
			var sname = "TextOnPath";
			var ltr = "TxtP";
			break;
		case 4: 
			var sname = "ControlPath";
			var ltr = "CtrlP";
			break;
		case 5: 
			var sname = "DropShadow";
			var ltr = "DropS";
			break;
		case 6: 
			var sname = "Contour";
			var ltr = "Contur";
			break;
		case 7: 
			var sname = "Distortion";
			var ltr = "Dist";
			break;
		case 8: 
			var sname = "Perspective";
			var ltr = "Persp";
			break;
		case 9: 
			var sname = "Lens";
			var ltr = "Lens";
			break;
		case 10: 
			var sname = "CustomEffect";
			var ltr = "CustEff";
			break;
		case 11: 
			var sname = "InnerShadow";
			var ltr = "InnerS";
			break;
	}
	ret['name'] = sname;
	ret['ltr'] = ltr;
	ret['type'] = effect.type;

	return ret;
}
function get_bitmap_mode(bmp){
	var ret = [];
	var name = "";
	switch (bmp.mode){
		case 0: name = "BW"; break;
		case 1: name = "16"; break;
		case 2: name = "Gray"; break;
		case 3: name = "Paletted"; break;
		case 4: name = "RGB"; break;
		case 5: name = "CMYK"; break;
		case 6: name = "DuoTone"; break;
		case 7: name = "LAB"; break;
		case 8: name = "CMYK Multy"; break;
		case 9: name = "RGB Multy"; break;
		case 10: name = "Spot Multy"; break;
	}
	ret['name'] = name;
	ret['mode'] = bmp.mode;
	return ret;
}

function get_color_info(colors, fountain){
	if(fountain === undefined) fountain = false;	
	var digs = [];
	var ret = [];
	var cols = [];
	if(fountain){
		for(var i=0;i<colors.count;i++) cols[i] = get_color_info(colors(i).color);
		var color = colors(0).color;
	}else{
		var color = colors;
	}
	switch (color.type){
		case 1: 
			var sname = "PANTONE";
			break;
		case 2: 
			digs[0] = color.CMYKCyan;
			digs[1] = color.CMYKMagenta;
			digs[2] = color.CMYKYellow;
			digs[3] = color.CMYKBlack;
			var sname = "CMYK";
			break;
		case 4: 
			digs[0] = color.CMYCyan;
			digs[1] = color.CMYMagenta;
			digs[2] = color.CMYYellow;
			var sname = "CMY";
			break;
		case 5:
			digs[0] = color.RGBRed;
			digs[1] = color.RGBGreen;
			digs[2] = color.RGBBlue;
			var sname = "RGB";
			break;
		case 6: 
			digs[0] = color.HSBHue;
			digs[1] = color.HSBSaturation;
			digs[2] = color.HSBBrightness;
			var sname = "HSB";
			break;
		case 7: 
			digs[0] = color.HLSHue;
			digs[1] = color.HLSLightness;
			digs[2] = color.HLSSaturation;
			var sname = "HLS";
			break;
		case 8: 
			digs[0] = color.BW;
			var sname = "BW";
			break;
		case 9: 
			digs[0] = color.Gray;
			var sname = "Gray";
			break;
		case 11: 
			digs[0] = color.YIQLuminanceY;
			digs[1] = color.YIQChromaI;
			digs[2] = color.YIQChromaQ;
			var sname = "YIQ";
			break;
		case 12: 
			digs[0] = color.LabLuminance;
			digs[1] = color.LabComponentA;
			digs[2] = color.LabComponentB;
			var sname = "LAB";
			break;
		case 14: 
			var sname = "PANTONE Hex";
			break;
		case 20: 
			var sname = "Registration";
			break;
		case 22: 
			var sname = "multi-channel";
			break;
		case 25: 
			var sname = "user ink";
			break;
		case 26: 
			var sname = "mixed";
			break;
		case 99: 
			digs[0] = color.SpotColorID;
			digs[1] = color.SpotColorName;
			var sname = "spot";
			break;
	}
	ret['name'] = color.Name;
	ret['sname'] = sname;
	if (fountain){
		ret['hex'] = cols[0]['hex']+":"+cols[1]['hex'];
		hnt = "";
		for(var i=0;i<colors.count;i++) hnt += cols[i]['sname'] + "(" + cols[i]['digs'].join(", ") + ")\n";
		ret['hint'] = hnt;
		ret['digs'] = cols;
	}else{
		ret['digs'] = digs;
		ret['hex'] = color.HexValue;
		ret['hint'] = sname + "(" + digs.join(", ") + ") ";
	}
	gray = color.GetCopy();
	gray.ConvertToGray();
	ret['gray'] = (gray.Gray<111) ? "#FFF" : "#000";

	return ret;
}

function select_color(ids){
	do_events(ids.id);
	instr = ids.name.indexOf("_sel");
	idstart = ids.name.substr(0,8);
	if(instr>0){
		if (idstart=='ffcoloir_') ids.innerHTML = ids.step; else ids.value = ids.step;
		ids.style.backgroundImage= "";
		ids.name=ids.name.substr(0,instr);
	}else{
		if (idstart=='ffcoloir_') ids.innerHTML = ""; else ids.value = "";
		ids.style.backgroundImage= "url('img/check.png')";
		ids.name=ids.name + "_sel";
	}
}
	
/* Corel functions*/	
function select_colors(){
	var srr;
	var arro = [];
	var arrf = [];
	var arff = [];
	var arre = [];
	var arrt = [];
	byGroups = (ch_selcol_group.checked || ch_selcol_move.checked) ? true : false;

	cfnd=false;
	srr = get_OS(false);

	if(byGroups) do_begin("group colors",true,glOptim);
	var elems = document.getElementsByTagName('*');
	for (var i = 0; i < elems.length; i++){
		elem = elems[i];
		if(elem.name=="outl_sel") {arro.push(elem.src); cfnd=true; select_color(elem); grAr = [arro, false, false, false, false]}
		if(elem.name=="fill_sel") {arrf.push(elem.src); cfnd=true; select_color(elem); grAr = [false, arrf, false, false, false]}
		if(elem.name=="ffill_sel") {arff.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, arff, false, false]}
		if(elem.name=="effects_sel") {arre.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, false, arre, false]}
		if(elem.name=="texts_sel") {arrt.push(elem.src); cfnd=true; select_color(elem); grAr = [false, false, false, false, arrt]}
		if(byGroups && cfnd){
			sr = do_each("select_colors",srr, false, grAr);
			if (ch_selcol_move.checked) sr.Move(srr.SizeWidth*1.2, 0);
			if (ch_selcol_group.checked) sr.Group();
			cfnd=false;
			arro = [];
			arrf = [];
			arff = [];
			arre = [];
			arrt = [];
		}
	}
	if(byGroups) do_end(true);
	if (cfnd){
		host.ActiveDocument.ClearSelection();
		shft = Shift();		
		srr = (shft==2 || shft==3) ? do_each("select_no_colors",srr,false,[arro,arrf,arff,arre,arrt]) : do_each("select_colors",srr,false,[arro,arrf,arff,arre,arrt]);
		if(shft==5 || shft==7){
			alay = host.ActiveLayer;
			lay = host.ActivePage.CreateLayer("xxxvirt");
			srr.MoveToLayer(lay)
			srr.MoveToLayer(alay)
			lay.Delete();
		}
	}
	return srr;
}

function make_contur(direct, src, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	shft = Shift();
	size = document.getElementById("val_cont_" + src);
	size_val = vall(size.value);
	if((shft==7 && OS.Shapes.Count>1) || (ch_master_sample.checked && master)){
		lst = (shft==7) ? OS.FirstShape : master;
		siz = lastSize(lst);
		if(siz>0){do_each("make_contur",OS,undogroup,[siz,direct]).CreateSelection();}
	}else if(shft>1 && shft!=5 && shft<7){
		pdir = (direct==1) ? 1 : -1;
		if(shft==2) host.ActiveLayer.CreateRectangle(OS.LeftX - size_val * pdir, OS.BottomY - size_val * pdir, OS.RightX + size_val * pdir, OS.TopY + size_val * pdir);
		if(shft==4) size.value = vall(size.value,false,4)+0.1*pdir;
		if(shft==6) size.value = vall(size.value,false,4)+0.5*pdir;
	}else{
		do_each("make_contur",OS,undogroup,[size_val,direct]).CreateSelection();
	}
	if (ch_cont_focus.checked) OS.CreateSelection();
	do_save(size);
}

function make_round(src, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	size = document.getElementById("val_cont_" + src);

	if((shft==7 && OS.Shapes.Count>1) || (ch_master_sample.checked && master)){
		lst = (shft==7) ? OS.FirstShape : master;
		siz = lastSize(lst);
		if (shft==7) OS.Remove(1);
	}else{
		siz = vall(size.value);
	}
	
	if(siz>0) do_each("round",OS,undogroup,siz).CreateSelection();
	do_save(size);
}	

function make_rotate(ang, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	if (ang=="center"){
		do_each("rotate_center",OS,undogroup).CreateSelection();
	}else{
		do_each("rotate",OS,undogroup,ang).CreateSelection();
	}
	do_save(val_rotate);
}	

function make_raspred(type, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS(false,false);
	if(defdoc()){
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		shft = Shift();
		do_save(val_raspred);
		do_begin("raspred_" + type, undogroup, glOptim);
		lst = OS.FirstShape;
		fst = OS.LastShape;	
		rval = vall(val_raspred.value);
		cnt_os = OS.Shapes.Count;
		
		if(type!="shapes"){
			lst_len = lst.DisplayCurve.Length;
			OS.Remove(1);
			cnt_os = OS.Shapes.Count;
		}
		OS = OS.ReverseRange;
		if(type=="nodes"){
				cnt_nd=1;
				for (var i=1;i<=lst.DisplayCurve.Nodes.Count;i++){
					nd = lst.DisplayCurve.Nodes(i);
					if (cnt_os==1){
						obj = OS.Shapes(1).Duplicate();
					}else if (cnt_os>=cnt_nd){
						obj = OS.Shapes(cnt_nd);
					}else{
						obj=false;
					}
					if (obj){
						only_line = false;
						if ((shft == 2 || shft == 3) && nd.PrevSegment && nd.NextSegment ){
							if (Math.abs(Math.abs(nd.PrevSegment.EndingControlPointAngle - nd.NextSegment.StartingControlPointAngle) - 180) < 1) only_line = true;
						}
						if (shft == 4 && nd.IsEnding) only_line = true;
						if ((shft<2 || shft>5) || only_line){
							moveC(obj, nd.PositionX, nd.PositionY);
							if (ch_raspred_rotate.checked){
								if (nd.NextSegment){
									ang = nd.NextSegment.StartingControlPointAngle;
								}else{
									ang = nd.Segment.EndingControlPointAngle + 180;
								}
								obj.rotate (ang);
							}
							cnt_nd++;
							sr.Add(obj);
						}else if (cnt_os==1){
							obj.Delete();
						}
					}
				}
		}else if(type=="dist" || type=="qty"){
			if (cnt_os==1){
				swi = fst.SizeWidth;
				if(type == "qty"){
					kol = rval;
					dist = (lst.DisplayCurve.Closed) ? lst_len / kol : lst_len / (kol - 1);
				}else{
					dist = (ch_raspred_center.checked) ? rval : rval+swi;
					kol = lst_len/dist + 1;
				}
			}else{
				kol = cnt_os;
				if(type=="qty") dist = lst_len / cnt_os;
			}
			var off = 0;
			var x = 0;
			var y = 0;
			for(var k=1;k<=kol;k++){
				var dlina_curvy = 0;
				for (var i=1;i<=lst.DisplayCurve.Segments.Count;i++){
					seg = lst.DisplayCurve.Segments(i);
					if(off >= dlina_curvy && off <= (dlina_curvy + seg.Length)){
						pts = seg.GetPointAt(off - dlina_curvy, 0);
						last_dist = 0;
						if(cnt_os > 1){
							obj = OS.Shapes(k);
							cur_dist = obj.SizeWidth/2;
							if(type=="dist") dist = (ch_raspred_center.checked) ? rval : rval+(cur_dist+last_dist);
							if (shft==2) dist = cur_dist+last_dist + (objn.leftx - obj.rightx)
							last_dist = cur_dist;
						}else{
							obj = fst.Duplicate();
						}
						moveC(obj, pts.x, pts.y);
						sr.Add(obj)
						if (ch_raspred_rotate.checked) obj.rotate (seg.GetTangentAt(off - dlina_curvy, 0));
						break;
					}
					dlina_curvy = dlina_curvy + seg.length;
				}
				off = off + dist;
				if(off > lst.DisplayCurve.length && type != "dist") off = lst.DisplayCurve.length;
			}

			allwi = 0;
			for (var i=1;i<=cnt_os;i++){
				allwi+=OS.SHapes(i).SizeWidth;
			}
		}else if(type=="shapes"){
			half = cnt_os/2;
			for (var i=1;i<=half;i++){
				if(shft==1 || shft==3 || shft==5 || shft==7){
					sd = OS.Shapes(i);
					ss = OS.Shapes(i+half);
				}else{
					ss = OS.Shapes(i);
					sd = OS.Shapes(i+half);
				}
				
				if(ch_raspred_rotate.checked){
					ss.RotationAngle = sd.RotationAngle;
					//ang = ss.RotationAngle;
					//sd.RotationAngle = ang;
				}
				if (shft>3){
					if (ss.Type==6) sd.Name = ss.Text.Story.Text;
				}else{
					sx = ss.RotationCenterX;
					sy = ss.RotationCenterY;
					moveC(ss, sd.RotationCenterX, sd.RotationCenterY);
					if(shft==2 || shft==3 || shft==6 || shft==7) moveC(sd, sx, sy);
				}
			}
		}else if(type=="round"){
			var cir_ang = 360 / cnt_os;
			for (var i=1;i<=cnt_os;i++){
				obj = OS.Shapes(i);
				obj.SetRotationCenter(lst.RotationCenterX,lst.RotationCenterY);
				dup = host.ActiveLayer.CreateLineSegment(obj.centerX, obj.centerY, lst.centerX, lst.centerY);
				cur_ang = dup.Curve.Segments.First.EndingControlPointAngle;
				if (i == 1) start_ang = (shft == 2) ? 90 : cur_ang;
				mang = start_ang  - (cur_ang + cir_ang * (i - 1));
				if (ch_raspred_rotate.checked){
					obj.rotate(mang);
				}else{
					dup.SetRotationCenter(lst.RotationCenterX,lst.RotationCenterY);
					dup.rotate(mang);
					moveC(obj, dup.Curve.Nodes.First.PositionX, dup.Curve.Nodes.First.PositionY);
				}
				dup.Delete();
				obj.SetRotationCenter(obj.centerX,obj.centerY);
			}
		}
		do_end(undogroup);
	}
	return sr;
}	
function make_freza(type, OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();
	if (OS.Shapes.Count<10)	do_each("freza",OS,undogroup,type).CreateSelection();
	do_save(val_freza);
}	

function make_gap(type, OS, undogroup){
	if(defdoc()){
		if(undogroup === undefined) undogroup = true;	
		if(OS === undefined) OS = get_OS(false,false);
		shft = Shift();
		do_save(val_razryv);
		do_begin("make gap " + type,undogroup, glOptim);
		host.ActiveWindow.Activate();
		if(type=="del"){
			OS.Shapes.FindShapes("krugi", 0, false, "@Name!='dsf'").Delete();
		}else if(ch_razryv_change.checked){
			do_razryv_change(OS);
		}else if (shft!=0 && OS.Shapes.Count>0){
			osw = OS.SizeWidth;
			for (var i=1;i<=OS.Shapes.Count;i++){
				gs = OS.Shapes(i);
				sx = gs.centerX;
				if(shft == 1 || shft == 5){
					gs.centerX = sx + osw;
					do_razryv (sx, gs.centerY);
					gs.centerX = sx;
				}else{
					do_razryv(gs.centerX, gs.centerY, gs);
				}
				if(shft < 3) gs.Delete();
			}
		}else{
			for (var i=1;i<=333;i++){
				var se = vbgetClick();
				if (se[0]==1) break;
				do_razryv(se[1],se[2]);
			}
		}
		//do_each("freza",OS,undogroup,type).CreateSelection();
		do_end(undogroup);
	}
}	

function make_rgb_cmyk(type){
	if(type === undefined) type = "rgb";
	shft = Shift();
	rastr = (isCtrl(shft)) ? true : false;
	do_rgb_cmyk (undefined, type, rastr, true).CreateSelection();
}

function do_rgb_cmyk(OS, type, rastr, undogroup){
	if(OS === undefined) OS = get_OS();
	if(rastr === undefined) rastr = false;	
	if(undogroup === undefined) undogroup = true;
	shft = Shift();
	cnt_os = OS.Shapes.Count;
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	if(cnt_os>0){
		do_begin("make nest " + type,undogroup, glOptim);
		cont = OS.FirstShape;
		//OS.Sort("@shape1.width*@shape1.height > @shape2.width*@shape2.height");
		cnt_fil=0;
		cnt_fnt=0;
		cnt_out=0;
		cnt_ras=0;
		for(var i=1;i<=cnt_os;i++){
			s = OS.Shapes(i);
			converted = false;
			if (type=="rgb"){
				if (s.Fill.Type == 1) if (s.Fill.UniformColor.Type != 5){ s.Fill.UniformColor.ConvertToRGB(); cnt_fil++; converted = true;}
				if (s.Fill.Type == 2){
					for(var c=0;c<s.Fill.Fountain.Colors.Count;c++){
						if (s.Fill.Fountain.Colors(c).Color.Type != 5) s.Fill.Fountain.Colors(c).Color.ConvertToRGB();
					}
					cnt_fnt++;
					converted = true;
				}
				if (s.Outline.Type == 1) if(s.Outline.Color.Type!=5){ s.Outline.Color.ConvertToRGB(); cnt_out++; converted = true;}
				if (s.type == 5){
					if (shft==6) {
						s = s.ConvertToBitmapEx(4,0,1,vall(val_rgb_dpi.value,false));
						cnt_ras++; 
						converted = true;
					} else {
						if (rastr) if(s.Bitmap.Image.Type!=4){
							s.Bitmap.ConvertTo(4);
							cnt_ras++; 
							converted = true;
						}
					}
				}
				if (shft==4) {s = s.ConvertToBitmapex(4, false, true, val_rgb_dpi.value);cnt_ras++;converted = true;}
			}else{
				if (s.Fill.Type == 1) if (s.Fill.UniformColor.Type != 2){ s.Fill.UniformColor.ConvertToCMYK(); cnt_fil++; converted = true;}
				if (s.Fill.Type == 2){
					for(var c=0;c<s.Fill.Fountain.Colors.Count;c++){
						if (s.Fill.Fountain.Colors(c).Color.Type != 2) s.Fill.Fountain.Colors(c).Color.ConvertToCMYK();
					}
					cnt_fnt++;
					converted = true;
				}
				if (s.Outline.Type == 1) if(s.Outline.Color.Type!=2){ s.Outline.Color.ConvertToCMYK(); cnt_out++; converted = true;}
				if (s.type == 5) {
					if (shft==6) {
						s = s.ConvertToBitmapEx(5, false, true, val_rgb_dpi.value);
						cnt_ras++; 
						converted = true;
					}else{
						if (rastr) if(s.Bitmap.Image.Type!=5){
							s.Bitmap.ConvertTo(5);
							cnt_ras++;
							converted = true;							
						}
					}
				}
				if (shft==4) {s = s.ConvertToBitmapex(5, false, true, val_rgb_dpi.value);cnt_ras++;converted = true;}
			}
			if (converted) sr.Add(s);
				//if(sr.Shapes.Count>0) sr.CreateSelection();
		}
		if (cnt_fil + cnt_fnt + cnt_out + cnt_ras > 0){
			fil = (cnt_fil>0) ? lang['text_fill'] + ": " + cnt_fil + CR : "";
			fnt = (cnt_fnt>0) ? lang['text_ffill'] + ": " + cnt_fnt + CR : "";
			out = (cnt_out>0) ? lang['text_outline'] + ": " + cnt_out + CR : "";
			ras = (cnt_ras>0) ? lang['text_rastr'] + ": " + cnt_ras + CR : "";
			result = lang['text_change'] + ":" + CR + fil + fnt + out + ras
		}else{
			result = lang['text_no_find'];
		}
			warn(result);
		do_end(undogroup);
	}
	return sr;
}

function do_print_check(OS, shft, undogroup){
	if(OS === undefined) OS = get_OS(true, true);
	if(undogroup === undefined) undogroup = true;
	if(shft === undefined) shft = Shift();	
	var msgs = [0,0,0,0,0,0,0,0,0,0,0,0,0];
	var changed = 0;
	
	cnt_os = OS.Shapes.Count;
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	if(cnt_os>0){
        sr_err = host.ActiveSelectionRange;
        sr_err.RemoveAll();
        if(shft == 2) do_begin("make nest " + shft,undogroup, glOptim);

		for(var i=1;i<=cnt_os;i++){
			s = OS.Shapes(i);	
//			alert(s.PowerClip);
            if(s.PowerClip != null){
                if (shft != 4){ msgs[7]++; sr_err.Add(s);}
			}else if (s.Effects.Count == 0 && s.Type < 11){
                if (s.Type == 6) if (shft == 2) {s.ConvertToCurves(); changed++;}else if (shft != 4){ msgs[6]++; sr_err.Add(s);}

                if (s.Type == 5){
                    if (s.Bitmap.ResolutionX > 1200 || s.Bitmap.ResolutionY > 1200){
                        msgs[5]++;
                        sr_err.Add(s);
                    }else{
                        if (shft == 6) if (s.Bitmap.mode == 4){ s.ApplyEffectBCI (-1, 0, 0);  changed++;} else{ s.ApplyEffectBCI (-2, 0, 0); changed++;}
					}
                }else{
                    if (s.Outline.Type == 1){
                        colo = s.Outline.color;
                        if (colo.Type == 5) if (colo.RGBBlue + colo.RGBGreen + colo.RGBRed == 255 + 255 + 255) if (shft == 2){colo.RGBAssign (253, 253, 253);  changed++;} else if (shft != 1){ msgs[1]++; sr_err.Add(s);}
                        if (colo.Type == 2) if (colo.CMYKCyan + colo.CMYKMagenta + colo.CMYKYellow + colo.CMYKBlack == 0) if (shft == 2){colo.CMYKCyan = 1;  changed++;}else if (shft != 1){ msgs[2]++; sr_err.Add(s);}
					}
                    if (s.Fill.Type != 0){
                        if (s.Fill.Type == 1){
                            colo = s.Fill.UniformColor;
							if (colo.Type == 5) if (colo.RGBBlue + colo.RGBGreen + colo.RGBRed == 255 + 255 + 255) if (shft == 2) {colo.RGBAssign(253, 253, 253);  changed++;}else if (shft != 1){ msgs[1]++; sr_err.Add(s);}
                            if (colo.Type == 2) if (colo.CMYKCyan + colo.CMYKMagenta + colo.CMYKYellow + colo.CMYKBlack == 0) if (shft == 2){ colo.CMYKCyan = 1;  changed++;} else if (shft != 1){ msgs[2]++; sr_err.Add(s);}
                        }else{
                            if (shft != 1) {sr_err.Add(s); msgs[3]++;}
						}
                    }
                }
            }else{
                if (shft != 4){ sr_err.Add(s); msgs[4]++;}
            }
		}
        if (sr_err.Shapes.Count > 0){
            sr_err.CreateSelection();
            result = "";
			msgs[13] = cnt_os;
            if (shft == 1 || shft == 4) msgs[13] = 0;
            for(var i=1;i<12;i++){
                if (msgs[i] > 0){
                    if (i < 13) msgs[13] -= msgs[i];
                    switch (i){
                        case 1: errd = lang['text_prn_RGB_255']; break;
                        case 2: errd = lang['text_prn_CMYK_0']; break;
                        case 3: errd = lang['text_prn_badfill']; break;
                        case 4: errd = lang['text_prn_effects']; break;
                        case 5: errd = lang['text_prn_resolution']; break;
                        case 6: errd = lang['text_prn_text']; break;
                        case 7: errd = lang['text_prn_powerclip']; break;
                        //case 12: errd = CR + "Changed"; break;
                        //case 13: errd = CR + "Good"; break;
                    }
                    result = result + errd + chr(9) + "  " + msgs[i] + CR;
                }
			}
        }else{
            result = lang['prn_check_ok'];
		}
		cha = (changed>0) ?  replaceAll(lang['prn_check_change'],"{OBJ}", changed) + CR + CR : "";		
		result = cha + result;
		warn(result);
		if (shft == 2) do_end(undogroup);
	}
	return sr_err;
}

function find_doubles(){
	do_begin("find doubles",true, glOptim);
	do_save(val_doubles_gap);
	do_doubles(vall(val_doubles_gap.value)).CreateSelection();
	do_end(true);
}

function do_doubles(gap, OS, shft){
	if(gap === undefined) gap = 0.1;
	if(OS === undefined) OS = host.ActiveSelectionRange;
	if(shft === undefined) shft = Shift();	
		
	cnt_os = OS.Shapes.Count;
	var sr = host.ActiveSelectionRange;
	if(cnt_os>0){
		sr.RemoveAll();
		params =  ["pos", "len"];
		if(gap<0) params.push("size");
		if (shft>3) params.push("subp");
		var arr = getArrOS(OS, params);
		var darr = [];
		var spdarr = [];
		warn(lang['doubles_in_process'], false);
		var seconds = new Date().getTime()/1000;
		for(var i=1;i<arr.length;i++){
			for(var d=i+1;d<arr.length;d++){
				if (shft>3 && shft<7 && i!=d){
					if(arr[i]['cnt']==0 && arr[d]['cnt']==0){
						for (var si=1;si<arr[i]['sp'].length;si++){
							for (var di=1;di<arr[d]['sp'].length;di++){
								//alert(i + "("+si+"):" + d + "("+di+") = " + arr[d]['sp'].length);
								if(arrFndDouble(arr[i]['sp'][si], arr[d]['sp'][di], gap, false)){
									bigs = (shft==6) ? arr[i]['sp']['cnt']<arr[d]['sp']['cnt'] : arr[i]['sp']['cnt']>arr[d]['sp']['cnt'];
									delid = (bigs) ? d : i;
									delspid = (bigs) ? di : si;
									if(!spdarr[delid]) spdarr[delid] = [];
									spdarr[delid][delspid] = delspid;
								}
							}
						}
					}
				}else if (arrFndDouble(arr[i], arr[d], gap)){
					darr[d] = d;
					if (shft==7) darr[i] = i;
				}
			}
		}
		sr_cnt=0;
		if (shft>3 && shft<7){
			for(var key in spdarr){
				spd = spdarr[key].reverse();
				for(var spk in spd){
					OS.Shapes(Number(key)).ConvertToCurves();
					OS.Shapes(Number(key)).Curve.Subpaths(spd[spk]).Delete();
					sr_cnt++;
					//if (OS.Shapes(Number(key)).Curve.Subpaths.Count==0) sr.Add (OS.Shapes(Number(key)));
					//alert(key +":"+ spd[spk]);
				}
			}
		}else{
			for(var key in darr){sr.Add(OS.Shapes(Number(key)));}	
			sr_cnt = sr.Shapes.Count;
			if (shft!=2 && shft!=3){sr.Delete(); sr = OS;}
		}
		var seconds2 = new Date().getTime()/1000;
		warn(lang['doubles_finish'] + sr_cnt + " : " +  getRound(seconds2 - seconds,3) + "s");
	}
	return sr;
}

function getArrOS(OS, params){
	if(OS === undefined) OS = get_OS();
	if(params === undefined) params = ['position','size'];
	var ret = [];
	cnt_os = OS.Shapes.Count;
	if(cnt_os>0){
		for(var i=1;i<=cnt_os;i++){
			s = OS.Shapes(i);
			ret[i] = [];
			ret[i]['id'] = i;
			ret[i]['cnt'] = s.Shapes.Count;
			for(var key in params){
				switch (params[key]){
					case "pos":
					case "position": ret[i]['px'] = s.PositionX; ret[i]['py'] = s.PositionY; ret[i]['cx'] = s.CenterX; ret[i]['cy'] = s.CenterY; break;
					case "size": ret[i]['l'] = s.LeftX; ret[i]['r'] = s.RightX; ret[i]['t'] = s.TopY; ret[i]['b'] = s.BottomY; ret[i]['w'] = s.SizeWidth;ret[i]['h'] = s.SizeHeight; break;
					case "rot":
					case "rotation": ret[i]['rx'] = s.RotationCenterX; ret[i]['ry'] = s.RotationCenterY; break;
					case "len":
					case "length": ret[i]['len'] = (isDCurve(s)) ? s.DisplayCurve.Length : 0; break;
					case "subp":
					case "subpath": 
						if (isDCurve(s)){
							ret[i]['sp'] = [];
							ret[i]['sp']['cnt'] = s.DisplayCurve.Subpaths.Count;
							for (var spi=1;spi<=ret[i]['sp']['cnt'];spi++){
								sp = s.DisplayCurve.Subpaths(spi);
								//alert(i+":"+spi+"::" + s.DisplayCurve.Subpaths.Count);
								ret[i]['sp'][spi] = [];
								ret[i]['sp'][spi]['id'] = spi;
								ret[i]['sp'][spi]['px'] = sp.PositionX; 
								ret[i]['sp'][spi]['py'] = sp.PositionY; 
								ret[i]['sp'][spi]['len'] = sp.Length; 
							}
						}
						break;
				}
			}
		}
	}
	return ret;
}

function arrInBound(ss,s,gap){
	return (ss['id']==s['id']) ? false : (ss['l'] < s['r'] + gap && ss['r'] > s['l'] - gap && ss['b'] < s['t'] + gap && ss['t'] > s['b'] - gap);
}
function arrFndDouble(ss,s,gap,checkid){
	if(checkid === undefined) checkid = true;
	var ret = false;
	if (ss['id']!=s['id'] || !checkid){
		if (gap<0){
			var sgap = Math.abs(gap);
			ret = (Math.abs(ss['w']-s['w'])<=sgap && Math.abs(ss['h']-s['h'])<=sgap && Math.abs(ss['len']-s['len'])<=sgap*4 && ss['len']>0 && s['len']>0)
		}else{
			ret = (Math.abs(ss['px']-s['px'])<=gap && Math.abs(ss['py']-s['py'])<=gap && Math.abs(ss['len']-s['len'])<=gap*4 && ss['len']>0 && s['len']>0);
		}
	}
	return ret;
}

function close_all(){
	if (defdoc()){
		var shft = Shift();
		var idoc = host.ActiveDocument.Index;
		host.Clipboard.Clear();
		var cur = (shft>0) ? 0 : 1;
		curd=1;
		cnt=0;
		while (host.Documents.Count!=cur && cnt <= host.Documents.Count+5){
			var cdoc = host.Documents(curd);
			if (idoc!=curd || cur==0){
				if (shft != 1 || cdoc.fileName == "") cdoc.Dirty = false; else cdoc.Save();
				cdoc.Close();
				if (idoc>1) idoc--;
			}
			if (idoc==1 && cur==1) curd=2;
			cnt++;
		}
	}
}

function make_pupyrki(OS, undogroup){
	if(OS === undefined) OS = get_OS();
	shft = Shift();
	cnt_os = OS.Shapes.Count;
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	if(cnt_os>0){
		do_begin("pupyrki ",undogroup, glOptim);
		if ((shft==4 || shft==5) && master){
			pup = master
		}else{
			pup = OS.FirstShape;
			OS.Remove(1);
			cnt_os--;
		}
		if (pup.SizeHeight > pup.SizeWidth) pupmax = pup.SizeHeight; else pupmax = pup.SizeWidth;
		do_save(val_kbx_th);
		do_save(val_kbx_pup_dif);
		bth = vall(val_kbx_th.value);
		sdif = vall(val_kbx_pup_dif.value);
		for(var i=1;i<=cnt_os;i++){
			s = OS.Shapes(i);
			fnd = false;
            if (s.DisplayCurve !=null && s.Type!=6){
				for(var si=1;si<=s.DisplayCurve.Segments.Count;si++){
					seg = s.DisplayCurve.Segments(si);
                    if (Math.abs(seg.length - bth) <= sdif / 100 * bth){
						ang = seg.GetPerpendicularAt();
						arrxy = vbGetPointPositionAt(seg);
						xx = vall(arrxy[0], false);
						yy = vall(arrxy[1], false);
						//alert ((xx - pup.centerX) + ":" + xx + " : " + yy);
						//host.ActiveLayer.CreateEllipse2(xx,yy,bth/2);
						fird = moveC(pup, xx, yy, "C");
						if (ch_kbx_pup_rotate.checked) if (pup.SizeHeight > pup.SizeWidth) fird.Rotate(ang); else fird.Rotate(ang + 90);
						sr.Add(fird);
						fnd = true;
					}
				}								
			}
			if (fnd) sr.Add(s);
		}
		do_end(undogroup);
	}
	return sr;
}

function make_webcam(mode){
	if(mode === undefined) mode = 'get_pic';
	if(defdoc()){
		grname = "grab_webcam";
		do_begin("get webcam", true, glOptim);
		//do_save(val_webcam_picang);
		//do_save(val_webcam_picwi);
		do_save(val_webcam_gapx);
		do_save(val_webcam_gapy);
		do_save(val_webcam_bwi);
		do_save(val_webcam_bhi);
		shft = Shift();
		if(mode=="get_ang"){
			//if (host.ActiveSelectionRange.Shapes.Count>0) val_webcam_picang.value = host.ActiveShape.RotationAngle;
			//do_save(val_webcam_picang);
		}else if(shft==1){
			ShapesUnlock(host.ActivePage.Shapes.FindShapes(grname)).Delete();
		}else if(shft==2){
			showhide('sett_webcam');
		}else if(mode=="get_dis"){
			if (shft==4){
				host.ActiveLayer.CreateCurve (getCurvefromStr(val_webcam_dis.value));
			}else {
				if (host.ActiveSelectionRange.Shapes.Count>0){
					if (host.ActiveShape.Effects.EnvelopeEffects.Count==1){
						val_webcam_dis.value = getStrfromCurve(host.ActiveShape.Effects.EnvelopeEffects(1).Envelope.Container);
						do_save(val_webcam_dis);
						//vbWriteFile(host.UserDataPath + "ar_envel.txt", v);
						//vbWebcamSaveDis("envel");
					}
				}
			}
		}else{
			shps = host.ActivePage.Shapes.FindShapes(grname);
			//var ang   = vall(val_webcam_picang.value,false);
			//var picwi = vall(val_webcam_picwi.value);
			var gapx  = vall(val_webcam_gapx.value);
			var gapy  = vall(val_webcam_gapy.value);
			var SizeX  = vall(val_webcam_bwi.value);
			var SizeY  = vall(val_webcam_bhi.value);
			
			pic = (shft==4) ? host.ActiveShape : (ch_webcam_fhd.checked) ? vbWebcamGetImg(1920, 1080) :  vbWebcamGetImg(1280, 720);
			if(pic!=null){
				//if (picwi>10) pic.SetSize(picwi);
				if((ch_webcam_dis.checked || shft==4) && val_webcam_dis.value.split(chr(10)).length>2){
					if(ch_webcam_180.checked) pic.Rotate(180);
					ef = pic.CreateEnvelope(2, 1 /*cdrEnvelopeOriginal*/, false);
					ef.Envelope.CopyFromCurve(getCurvefromStr(val_webcam_dis.value));
					ef.Envelope.mode = 1;
					//pic = vbWebcamCorrect(pic);
				}
				if (shft!=4){
					//if(ch_webcam_picang.checked) pic.rotate(ang);
					if(shps.Shapes.Count>0 && ch_webcam_same.checked){
						moveC(mx, shps.LastShape.CenterX, shps.LastShape.CenterY);
					}else{
						moveC (pic);
					}
					if(ch_webcam_del.checked){
						ShapesUnlock(shps).Delete();
					}
				}
				pic.name = grname;
				pic.OrderToBack();
				//pic = pic.CustomCommand("Crop", "CropRectArea", pic.LeftX + gapx, pic.TopY - gapy, pic.RightX, pic.BottomY).FirstShape;

				sq = host.ActiveLayer.CreateRectangle2(pic.LeftX+gapx, pic.TopY-gapy-50, 50, 50);
				sq.Outline.Color.RGBAssign(255,255,0);
				//sq2.name = grname + "_pos";
				sq.OrderFrontOf(pic);
				if(ch_webcam_frame.checked){
					host.ActiveLayer.CreateRectangle2(sq.LeftX, sq.topy-SizeY, SizeX, SizeY);
				}
				

				if(ch_webcam_lock.checked){
					pic.locked = true;
					sq.locked = true;
				}
				
				if(ch_webcam_zoom.checked) host.ActiveWindow.ActiveView.ToFitShape(pic);
			}
		}
		do_end(true);
	}
}

function list_add(){
	if (defdoc()){
		shft = Shift();
		cur = add_lists.value.split("x");
		list_save = false;
		os = get_OS(false,false,false);
		if ((shft==4 || shft==0) && cur.length>1){
			if (shft==4){
				var a = cur[0];
				cur[0] = cur[1];
				cur[1] = a;
			}

			if(os.shapes.count>0){
				xx = os.LeftX;
				yy = os.TopY - vall(cur[1]);
			}else{
				xx = host.ActiveWindow.ActiveView.OriginX - vall(cur[0])/2;
				yy = host.ActiveWindow.ActiveView.OriginY - vall(cur[1])/2;
			}
			host.ActiveLayer.CreateRectangle2 (xx, yy, vall(cur[0]), vall(cur[1]));
		}else if (shft==1 && os.Shapes.Count>0){
			sep = (val_add_lists.value.length>5) ? val_add_lists.value : "";
			val = os.SizeWidth + "x" + os.SizeHeight;
			if (val_add_lists.value.indexOf(val) < 0) {
				val_add_lists.value = sep + val + ":";
				list_save = true;
			}
		}else if (shft==2 && confirm(lang['list_add_del'] + add_lists.value + "?")){
			sep = val_add_lists.value.split(":");
			out = "";
			for(var i=0;i<sep.length;i++){
				if (sep[i].length>3){
					csep = sep[i].split("x");
					if (cur[0]!=csep[0] || cur[1]!=csep[1]) out += sep[i] + ":";
				}
			}
			val_add_lists.value = out;
			list_save = true;
		}
		do_save(add_lists);
		if (list_save) do_save(val_add_lists);
	}
}

function do_razryv(xx, yy, sha){
	if(sha === undefined) sha = false;
    var gap = vall(val_razryv.value)/2;
	var rgb = hextorgb(gapcolor.value);
	var RR = rgb[0];
	var GG = rgb[1];
	var BB = rgb[2];
	sel = host.ActivePage.SelectShapesAtPoint(xx, yy, false).Shapes.All();
	if(sha) for (var i=1;i<=sel.Shapes.Count;i++) if(sel.Shapes(i) == sha) sel.Remove(i);

  
    harea = (sha) ? sha.SizeHeight * sha.SizeWidth / 3 : harea = 0.1;
    if(sel.Shapes.Count > 0){
        for (var i=1;i<=sel.Shapes.Count;i++){
			var s = sel.Shapes(i);
            seg = false;
            if(s.Shapes.Count == 0){
                s.ConvertToCurves();
                seg = s.Curve.FindSegmentAtPoint(xx, yy, 0, harea);
            }else{
				ssel = getInGroup(s.Shapes.All());
				for (var si=1;si<=ssel.Shapes.Count;si++){
					ss = ssel.Shapes(si);
                    ss.ConvertToCurves();
                    seg = ss.Curve.FindSegmentAtPoint(xx, yy, 0, harea);
                    if (seg){s = ss; break;}
				}
			}
            
            if (seg){
                off = vbgetSegOffbyXY(seg, xx, yy);
				seg.BreakApartAt(off);

				ci = (sha) ? sha.Duplicate() : host.ActiveLayer.CreateEllipse2(xx, yy, gap);
				
				if(ch_razryv_circle.checked){
					cibig = host.ActiveLayer.CreateEllipse2(xx, yy, gap*2);
					cibig.name = "krugi";
					cibig.Outline.Color = host.CreateRGBColor(BB, GG, RR);
				}
				
				if(ch_razryv_nedorez.checked) s.Intersect(ci).Outline.Color = host.CreateRGBColor(RR,GG,BB);

				ci.Trim(s, false);
			}	
		}
	}
}

function do_razryv_change(OS, nedorez, circles){
	if(OS === undefined) OS = get_OS();
	if(nedorez === undefined) nedorez = ch_razryv_nedorez.checked;	
	if(circles === undefined) circles = ch_razryv_circle.checked;	
	
	shft = Shift();
	cnt_os = OS.Shapes.Count;
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	do_save(val_nest_qty);
	if(cnt_os>0){
		do_begin("make nest " + type,undogroup, glOptim);
		cont = OS.FirstShape;
		//OS.Sort("@shape1.width*@shape1.height > @shape2.width*@shape2.height");
		OS.Remove(1);
		for(var i=1;i<=cnt_os;i++){
			s = OS.Shapes(i);	
			//if(sr.Shapes.Count>0) sr.CreateSelection();
		}
		do_end(undogroup);
	}
	return sr;
}

function do_nest_place(OS, gapx, gapy, sort, type, undogroup){
	if(type === undefined) type = "pack";	
	if(sort === undefined) sort = !ch_nest_nosort.checked;	
	if(gapx === undefined) gapx = vall(val_nest_gapx.value);	
	if(gapy === undefined) gapy = vall(val_nest_gapy.value);	
	
	shft = Shift();
	
	do_save(val_nest_qty);
	do_save(val_nest_gapx);
	do_save(val_nest_gapy);

	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();

	master_exist = vbgetExist(mastercont);
	if ((shft==3 || mastercont!=null && !master_exist) && shft!=1){
		if (mastercont!=null && !master_exist) alert(lang['text_no_container']);
		mastercont = null;
		nest_place.style.backgroundColor = "";
	}else{
		if(OS === undefined) OS = get_OS(false, false);
		if(undogroup === undefined) undogroup = true;	
		cnt_os = OS.Shapes.Count;
		if(cnt_os>0){
			var areas = [];
			do_begin("make nest " + type,undogroup, glOptim);
			//OS.Sort("@shape1.width*@shape1.height > @shape2.width*@shape2.height");
			//alert(vbgetExist(mastercont));

			cont = OS.FirstShape;
			if(cnt_os>1 && mastercont!=null){
				//if (mastercont.SizeWidth == cont.SizeWidth && mastercont.SizeHeight == cont.SizeHeight) shft=1;
			}			
			if (mastercont==null || shft==1 ){
				if (shft==1 || shft==5 || shft==7){
					mastercont = cont;
					nest_place.style.backgroundColor = "#E88";
				}
				OS.Remove(1);
				cnt_os--;
			}
			if (cnt_os==1 && mastercont!=null){
				if (mastercont.SizeWidth == cont.SizeWidth && mastercont.SizeHeight == cont.SizeHeight) cnt_os--;
			}
			qty = vall(val_nest_qty.value,false);
			if (isAlt(shft) && qty>1) OS.AddRange(OS.StepAndRepeat(qty-1,1,0).ReverseRange);
			sr.AddRange(OS);			
			cnt_os = OS.Shapes.Count;
			var last_cnt = 0;
			OS = OS.ReverseRange;
			if (cnt_os>0){
				if (mastercont!=null /*&& shft!=1*/){
					warn(lang["nest_start"], false);
					while (cnt_os > 0 && cnt_os != last_cnt){
						last_cnt = OS.Shapes.Count;
						OS = host.GMSManager.RunMacro("wpanel", "Macros.place_in_container", OS,mastercont, ch_nest_bywidth.checked, sort, vall(val_nest_gapx.value), vall(val_nest_gapy.value), shft, ch_nest_byform.checked);
						cnt_os = OS.Shapes.Count;
						if (OS.count>0 && cnt_os != last_cnt) mastercont = mastercont.Duplicate(0,-mastercont.SizeHeight*1.2);
					}
					/*for(var i=1;i<=cnt_os;i++){
						s = OS.Shapes(i);
						moveC(s, mastercont.centerX, mastercont.centerY, false, true);
					}*/
					warn(lang["nest_stop"]);
				}else{
					warn(lang["nest_start"], false);
					if(!sort && shft==2) OS = OS.ReverseRange;
					for(var i=1;i<=cnt_os;i++){
						s = OS.Shapes(i);
						if(ch_nest_rotate.checked)  if(s.SizeWidth < s.SizeHeight) s.Rotate(90);
						srt = (ch_nest_bywidth.checked) ? s.SizeWidth : s.SizeHeight;
						areas[i] = [srt,i,s.SizeWidth,s.SizeHeight,0,0,0];
					}
					ssx = sx = cont.leftx+gapx;
					ssy = sy = cont.topy-gapy;
					sw = cont.SizeWidth - gapx;
					sum = 0;
					maxh = 0;
					lasti = 0;
					if(sort) if (shft==2) areas.sort(sort2D); else areas.sort(rsort2D);
					for(var i=0;i<=areas.length;i++){
						if(areas[i]){
							var ind = areas[i][1];
							var wi  = areas[i][2];
							var hi  = areas[i][3];
							if (ind>0){
								sum += wi+gapx;
								if (maxh<hi){maxh = hi}
								if (sum>sw){
									sum -= wi;
									fnd = arrFindNst(areas,i+1,sw-sum,2,maxh);
									if (fnd && sort){
										ins = areas[fnd];
										areas.splice(fnd,1);
										areas.splice(i,0,ins);
										sum += ins[2]+gapx;
										hi = ins[3];
									}else{
										sum = wi+gapx;;
										areas[i][4] = maxh;
										if (lasti>0) areas[lasti][5] = maxh;
										maxh=0;
										lasti = i;
									}
								}
								if (maxh<hi){maxh = hi}
							}
						}
					}
					var lhi = 0;
					var row_cnt = 0;
					var slast = false;
					if (ch_nest_snake.checked){
						var rw = host.ActiveSelectionRange;
						rw.RemoveAll();
					}
					for(var i=0;i<=areas.length;i++){
						if(areas[i]){
							var ind = areas[i][1];
							var wi  = areas[i][2];
							var row = areas[i][4];
							var nrow = areas[i][5];
							if(nrow>0) lhi = nrow;
							if (ind>0){
								s = OS.Shapes(ind);
								if (areas[i-1] && ch_nest_snake.checked) if(shft==2) s.OrderBackOf(OS.Shapes(areas[i-1][1])); else s.OrderFrontOf(OS.Shapes(areas[i-1][1]));
								if (row>0){
									sy -= row+gapy;
									if ((sy-nrow-gapy)<cont.bottomy+gapy){
										//alert(nrow);
										cont = cont.Duplicate(0, -cont.SizeHeight*1.2);
										sy = cont.topy-gapy;
									}
									sx = ssx;
									if(row_cnt % 2 != 0 && ch_nest_snake.checked) { rw.leftx = ssx; rw.RemoveAll();}
									row_cnt++;
								}
								if(s.SizeWidth<lhi && s.SizeHeight<s.SizeWidth && ch_nest_rotate.checked) s.Rotate(90);
								moveC(s, sx, sy, false, "TL");
								if(ch_nest_snake.checked && row_cnt % 2 != 0){
									sx -= wi + gapx;
									rw.Add(s);
								}else{
									sx += wi + gapx;}
							}
						}
					}
					if (ch_nest_snake.checked) if (rw.Shapes.Count>0) {rw.leftx = ssx; rw.RemoveAll();}
					//if(sr.Shapes.Count>0) sr.CreateSelection();
					do_end(undogroup);
					warn(lang["nest_stop"]);
				}
			}
		}
	}
	return sr;
}

function SelectOfType(type){
	do_events("button_SelectOfType "+ type );
	shft = Shift();
	//host.ActiveDocument.ClearSelection();		
	switch (type){
		case "sel_close_open": sr = (shft==2 || shft==3) ? do_each("sel_open") : do_each("sel_close"); break;
		case "sel_fill_no": 
			if (shft==2 || shft==3)
				sr = do_each("sel_nofill");
			else if (shft==4 || shft==5)
				sr = do_each("sel_otherfill");
			else
				sr = do_each("sel_fill"); 
			break;
		case "powerclip": sr = (shft==2 || shft==3) ? do_each("sel_nopower") : do_each("sel_power"); break;
		case "sel_outl_no": sr = (shft==2 || shft==3) ? do_each("sel_nooutl") : do_each("sel_outl"); break;
		case "sel_images": sr = (shft==2 || shft==3) ? do_each("sel_noimages") : (shft==4) ? do_each("ssel_image_trans") : do_each("sel_images"); break;
		case "sel_effect_no": 
			if (shft==2 || shft==3){
				sr = do_each("sel_noeffect");
			}else if(shft==4 || shft==5){
				sr = do_each("break_effect"); 
			}else{
				sr = do_each("sel_effect"); 
			}
		break;
		case "sel_lock": sr = (shft==2 || shft==3) ? do_each("sel_unlock") : do_each("sel_lock"); break;
		case "text": sr = (shft==2 || shft==3) ? do_each("sel_notext") : do_each("sel_text"); break;
		case "curve": sr = (shft==2 || shft==3) ? do_each("sel_nocurve") : do_each("sel_curve"); break;
		case "rectangle": sr = (shft==2 || shft==3) ? do_each("sel_norectangle") : do_each("sel_rectangle"); break;
		case "ellipse": sr = (shft==2 || shft==3) ? do_each("sel_noellipse") : do_each("sel_ellipse"); break;
		case "polygon": sr = (shft==2 || shft==3) ? do_each("sel_nopolygon") : do_each("sel_polygon"); break;

		default:
			var OS = get_OS();
			var query = "@type='" + type + "'";
			if(shft==2 || shft==3){
				query = replaceAll(query,"=","!=");
				query = replaceAll(query,"or","and");
			}
			shft = Shift();
			var ingroups = (shft==1) ? true : false;
			sr = OS.Shapes.FindShapes("", 0, ingroups, query);
		break;
	}
	return sr;
}
function set_master(){
	shft = Shift();
	if (master && shft==2){
		master.CreateSelection();
		//zoom = host.ActiveWindow.ActiveView.Zoom;
		//host.ActiveWindow.ActiveView.ToFitShape(master);
		//host.ActiveWindow.ActiveView.OriginX = master.CenterX;
		//host.ActiveWindow.ActiveView.OriginY = master.CenterY;
		//host.ActiveWindow.ActiveView.Zoom = zoom;
	}else{
		master = host.ActiveShape;
	}
}

function master_fill(type, OS, undogroup){
	if(type === undefined) type = getRadio('group_master_fill').value;
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS(false,false);
	if (defdoc()){
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		shft = Shift();
		do_save(val_fill_kraj);
		do_save(val_fill_gap);
		if(master || isLast(OS)){
			lst = (shft==7) ? OS.FirstShape : master;
			siz = lastSize(lst);
			if (shft==7) OS.Remove(1);
			
			do_begin("master fill " + type,undogroup, glOptim);
			val_kraj = vall(val_fill_kraj.value);
			val_gap = vall(val_fill_kraj.value);
			cnt_os = OS.Shapes.Count;
			msx = lst.leftx;
			mex = lst.rightx;
			msy = lst.topy;
			mey = lst.bottomy;
			mw = lst.SizeWidth;
			mh = (lst.type == 4) ? mw : lst.SizeHeight;
			marea = lst.DisplayCurve.Area;
			
			dopusk = (shft == 1 || shft == 5) ? marea*0.07 : 0.1;

			if(ch_master_fill_bycenter.checked){
				xi = val_gap;
				yi = val_gap;
			}else{
				xi = val_gap + mw;
				yi = val_gap + mh;
			}
			
			if (shft>3 && shft<7) yi = yi/2*tg60;
			
			for(var sind=1;sind<=OS.Shapes.Count;sind++){
				s = OS.Shapes(sind);
				lst.OrderFrontOf(s);
				var dr = false;
				if(val_kraj != 0){
					dr = (val_kraj > 0) ? 0 : 1;
					s.CreateContour(dr, Math.abs(val_kraj), 1, 1, host.CreateCMYKColor(100, 100, 100, 100), host.CreateCMYKColor(100, 100, 100, 100), host.CreateCMYKColor(100, 100, 100, 100), 0, 0, 1, 2);
					if(s.Effects.Count > 0) s = s.Effects(1).Separate()(1);
				}
				sx = s.leftx;
				ex = s.rightx;
				sy = s.topy;
				ey = s.bottomy;
				
				row = 0;
				for(var yy=sy;yy>=ey;yy-=yi){
					row++;
					re = host.ActiveLayer.CreateRectangle(sx, yy, ex, yy - mh);
					isecr = s.Intersect(re);
					if(isecr){
						il = isecr.LeftX;
						ir = isecr.RightX;
						isecr.Delete();
					}else{
						il = ex;
						ir = sx;
					}
					re.Delete();
					sxx = (shft>3 && shft<7 && row % 2 == 0) ? sx-xi/2 : sx;
					for(var xx=sxx;xx<=ex;xx+=xi){
						if(xx >= il && xx <= ir || (type == "all" || type == "out" )){
							m = lst.Duplicate(xx - msx, yy - msy);
							if(type != "all"){
								isec = s.Intersect(m);
								del = true;
								if(isec){
									if(type == "full" && isec.DisplayCurve.Area > (marea - dopusk) || type == "part") del = false;
									isec.Delete();
								}else if (type == "out"){
									del = false;
								}
								if(del) m.Delete();
							}
						}
					}
				}
				if(val_kraj != 0) s.Delete();
			}
			do_end(undogroup);
		}
	}
}

function autogroup(group,OS,undogroup,param){
	if(group != undefined && host.ActiveDocument!=null){
		do_events(group);
		if(OS === undefined) OS = get_OS();
		if(undogroup === undefined) undogroup = true;
		shft = Shift();
		do_begin(group,undogroup, glOptim);
		var sr_all = host.ActiveSelectionRange;
		sr_all.RemoveAll();
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		var arr_all = [];
		var sgap =  vall(val_groupgap.value);
		do_save(val_groupgap);
		
		gcnt = OS.Shapes.Count;
		
		grpsimpl = false;
		if (group =="grp_simpl"){group = "grp_byform"; grpsimpl = true;}

		if (group=="grp_addto"){
            OS = OS.Shapes.FindShapes("", 7, false);
			for(var i=1;i<=OS.Shapes.Count;i++){
				s = OS.Shapes(i);
                sr.RemoveAll();
                sr.AddRange(s.UngroupEx());
                sr.Add(host.ActivePage.SelectShapesFromRectangle(sr.LeftX - sgap, sr.BottomY - sgap, sr.RightX + sgap, sr.TopY + sgap, true));
                sr.Group();
				if (sr.Shapes.Count > 0 ) sr_all.AddRange (sr);
            }
		}else{
			var seconds = new Date().getTime()/1000;
			var arr = getArrOS(OS, ["size"]);
			for(var i=1;i<arr.length;i++){
				var s = arr[i];
				arr_all[i] = [];
				arr_all[i][i] = i;
				for(var j=1;j<arr.length;j++){
					var ss = arr[j];
					if(i!=j){
						arr_all[i][j] = 0;
						if (arrInBound(ss,s,sgap)){
							if(group == "grp_byform"){
								isec = OS.Shapes(i).Intersect(OS.Shapes(j));
								if (isec){
									arr_all[i][j] = j;
									isec.Delete();
								}
							}else{
								arr_all[i][j] = j;
							}
						}
					}
				}
			}
			
			for(var i=1;i<=gcnt;i++){
				arr_all = collect_arr(arr_all, i, i);
			}	
			
			for(var i=1;i<=gcnt;i++){
				sr.RemoveAll();
				inar =0;
				for(var j=1;j<=gcnt;j++){
					if (arr_all[i][j]>0){
						sr.Add(OS.Shapes(j));
						inar++;
					}
				}

				if (inar > 1) {
					if (shft == 4 && (group == "grp_weld" || group == "grp_byform" || group == "grp_byframe")){
						sr.Combine();
					}else{
						if (group == "grp_byframe" || group == "grp_byform") {
							if (shft < 4)  sr_all.add(sr.Group());
						} else {
							sr.sort("@shape1.width*@shape1.height < @shape2.width*@shape2.height");

							fs = sr.FirstShape;
							ls = sr.LastShape;

							for(var k=1;k<=sr.Shapes.Count;k++){
								s = sr.Shapes(k);
								if (s != ls && s != fs) {
									fs = s.Weld(fs, false, false);
								}
							}
							if (group == "grp_weld") {
								ls = fs.Weld(ls, false);
							} else {
								ls = fs.Trim(ls, false);
							}
							if (ls) sr_all.add(ls);
						}
					}
				}else if (inar==1){
					if (sr(1).type == 6) sr(1).Weld(sr(1));
				}
			}
		var seconds2 = new Date().getTime()/1000;
		warn("Time : " +  getRound(seconds2 - seconds,3) + "s", false);			
		}

		if (group =="grp_byform" && grpsimpl){
			alert(1);
			var cnt = sr_all.Shapes.Count;
			for(var g=1;g<=cnt;g++){
				gcnt = sr_all.Shapes(g).Shapes.Count;
				if (gcnt>0){
					for(var i=1;i<=gcnt;i++){
						s = sr_all.Shapes(g).Shapes(i);
						for(var j=i+1;i<=gcnt;i++){
							ss = sr_all.Shapes(g).Shapes(j);
							
						}
					}
				}
			}
		}

		do_end(undogroup);
		return sr_all;
	}else{
		return 	getEOS();
	}		
}
// system functions

function collect_arr(arr, ci, ki) {
    for (var k = 0; k < arr.length; k++) {
        if (arr[ki][k] > 0) {
            arr[ci][k] = k;
            if (ki !== ci) {
                arr[ki][k] = null;
            }
            if (ci !== k && ki !== k) {
                arr = collect_arr(arr, ci, k);
            }
        }
    }
    //if (ki !== ci) { arr[ki][ki] = null; }
    return arr;
}

function do_each(name,OS,undogroup,param){
	if(name != undefined && host.ActiveDocument!=null){
		do_events(name);
		if(OS === undefined) OS = get_OS();
		if(undogroup === undefined) undogroup = true;
		shft = Shift();
		doall = true;
		var sr = host.ActiveSelectionRange;
		sr.RemoveAll();
		if(doall){		
			doeach=true;
			if (name!="repeat_last") do_begin(name,undogroup, glOptim);
			ch_lst = false;
			glst = OS.FirstShape;
			gfst = OS.LastShape;
			for (var i=1;i<=OS.Shapes.Count;i++){
				if (OS.Shapes(i).Shapes.Count==0) {
					fst = OS.Shapes(i);
					if(!ch_lst) lst = OS.Shapes(i);
					ch_lst = true;
				}
			}
			if(!vbgetExist(master)) master = false;
			var mlst = false;
			if(master) {
				mlst = master;
			}
			if(isLast(OS) && name!="make_sizes"){
				mlst = OS.FirstShape;
				if (name!="master_select") OS.Remove(1);
			}
			if (mlst){
				lst_siz = lastSize(mlst);
				lst_ang = max_ang(mlst);
				lst_per = lastSize(mlst,true);
			}
			isLastGl = isLast(OS,true);
			switch(name){
				case "make_contur":
					todel = (shft==5) ? !ch_cont_del.checked : ch_cont_del.checked; 
					if(param[2] === undefined) param[2] = ch_cont_sep.checked;
					if(param[3] === undefined) param[3] = todel;
					if(param[4] === undefined) param[4] = ch_cont_round.checked;
					if(param[5] === undefined) param[5] = ch_cont_reduce.checked;
					if(param[6] === undefined) param[6] = ch_cont_cut.checked;
					if(param[7] === undefined) param[7] = ch_cont_smart.checked;
					break;
				case "sel_toup":OS.OrderToFront(); doeach = false; break;
				case "sel_todown":OS.OrderToBack(); doeach = false; break;
				case "perimetr_get_size":val_perimetr.value = fst.DisplayCurve.Length*wScale; do_save(val_perimetr); doeach = false; break;
				case "perimetr_set_size":do_save(val_perimetr); break;
				case "punkt_get_dash": val_punkt_dash.value = fst.DisplayCurve.Segments.Count; do_save(val_punkt_dash); doeach = false; break;
				case "fefco": ffile = vbReadFile('fefco/'+fefco_list.value+'.ini', chr(10)); do_save(val_fefco_th);do_save(val_fefco_hi); fth = vall(val_fefco_th.value); fhi = vall(val_fefco_hi.value); break;		
				case "master_select": masterArea = (mlst) ? maxSPArea(mlst) : 0; break;
				case "set_sizes":  
					do_save(val_sizes_wi); do_save(val_sizes_hi); 
					if (shft==2){
						val_sizes_wi.value = glst.SizeWidth;
						val_sizes_hi.value = glst.SizeHeight;
						doeach = false;
					}
					break;
				case "numerate":
					if(!ch_num_reverse.checked) OS = OS.ReverseRange; 
					do_save(val_num_templ); do_save(val_num_start); do_save(val_num_step); do_save(val_num_digs); 
					num_templ=val_num_templ.value;
					num_cnt=vall(val_num_start.value,false);
					num_step=vall(val_num_step.value,false);
					num_digs=vall(val_num_digs.value,false);
				break;
				case "rotate": 
					var mang = vall(param,false);
					if(param=="ang"){
						var se = vbgetClick();
						if (se[0]==1) {doeach = false; break;}
						mang = FindSegXY(se[1],se[2], host.ActivePage.SelectShapesAtPoint(se[1],se[2], false)).StartingControlPointAngle;
						if (mang > 180) mang -= 180;
						if(se[3]==2) mang *= -1;
					}else if(param>0){
						if(isAlt(shft))	mang *= -1;
					}
				break;
				case "make_sizes": 
					OS.CreateSelection();
					if (shft!=6){
						if (ch_sizes_hor.checked){
							dr = (isCtrl(shft)) ? "up" : "dn";
							if (ch_sizes_betw.checked) dr +="b";
							vbMakeSize(dr, shft);
						}
						if (ch_sizes_ver.checked){
							dr = (isCtrl(shft)) ? "ri" : "lf";
							if (ch_sizes_betw.checked) dr +="b";
							vbMakeSize(dr, shft);
						}
						doeach = false;
					}
				break;
				case "freza": 
					freza_R = vall(val_freza.value)/2; 
					freza_Rk = freza_R * 4 / 3; 
					inp=false;
					if((shft==4 || shft==5) && !ch_freza_corners.checked){
						inp = prompt(lang["freza_title"],freza_R * 4 * wScale);
					}
				break;
				case "make_punktir":
					punkt_dash = vall(val_punkt_dash.value);
					punkt_gap = vall(val_punkt_gap.value);
					do_save(val_punkt_dash);
					do_save(val_punkt_gap);
					if(shft==4){
						doeach = false;
						var se = vbgetClick();
						if (se[0]==1) break;
						seg = FindSegXY(se[1],se[2], host.ActivePage);
						if(seg){
							for(var k=1;k<punkt_dash;k++){
								kf = 1-1/(punkt_dash-k+1);
								seg.AddNodeAt(kf,1);
							}
						}
					}
				break;
				case "mashtab_set_size": 
					len = (fst.DisplayCurve.Closed) ? max_size(fst) : fst.DisplayCurve.Length;
					inp = (isLastGl) ? lst_siz : prompt(lang["mashtab_title"],len * wScale);
					if (inp>0){
						coef = vall(inp) / len;
						OS.SizeWidth = OS.SizeWidth * coef;
						OS.SizeHeight = OS.SizeHeight * coef;
					}
					doeach = false; 
				break;
			}
			if(doeach){
				for(var sind=1;sind<=OS.Shapes.Count;sind++){
					s = OS.Shapes(sind);
					if(vbgetExist(s)){
						if(s.Locked){
							switch(name){
								case "sel_lock": sr.add(s); break;
								case "sel_unlock": if(s.Locked) {s.Locked=false; sr.add(s); }break;
							}
						}else{
							switch(name){
								case "sel_rectangle":if(s.Type==1) sr.add(s); break;
								case "sel_norectangle":if(s.Type!=1) sr.add(s); break;
								case "sel_ellipse":if(s.Type==2) sr.add(s); break;
								case "sel_noellipse":if(s.Type!=2) sr.add(s); break;
								case "sel_curve":if(s.Type==3) sr.add(s); break;
								case "sel_nocurve":if(s.Type!=3) sr.add(s); break;
								case "sel_polygon":if(s.Type==4) sr.add(s); break;
								case "sel_nopolygon":if(s.Type!=4) sr.add(s); break;
								case "sel_images": if(s.Type==5) sr.add(s); break;
								case "sel_noimages": if(s.Type!=5) sr.add(s); break;
								case "sel_text":if(s.Type==6) if(mlst){if (mlst.Text.Story.Font==s.Text.Story.Font) sr.add(s);} else sr.add(s); break;
								case "sel_notext":if(s.Type!=6) sr.add(s); break;
								case "sel_close":if(s.DisplayCurve!=null) if (s.DisplayCurve.Closed) sr.add(s); break;
								case "sel_open":if(s.DisplayCurve!=null) if (!s.DisplayCurve.Closed) sr.add(s); break;
								case "sel_fill":if(s.Type!=7 && s.Fill.Type==1) if(mlst){ if(mlst.Fill.Type==s.Fill.Type) if (mlst.Fill.UniformColor.RGBValue==s.Fill.UniformColor.RGBValue) sr.add(s);} else sr.add(s); break;
								case "sel_otherfill":if(s.Type!=7 && s.Fill.Type>1) sr.add(s); break;
								case "sel_nofill":if(s.Fill.Type==0) sr.add(s); break;
								case "sel_outl":if(isSimpleShape(s))if(s.Outline.Type>0) if(mlst){if (mlst.Outline.Color.RGBValue==s.Outline.Color.RGBValue && mlst.Outline.Width==s.Outline.Width) sr.add(s);} else sr.add(s); break;
								case "sel_nooutl":if(isSimpleShape(s))if(s.Outline.Type==0) sr.add(s); break;
								case "sel_image_trans": if(isSimpleShape(s))if(s.Outline.Type>0) sr.add(s); break;
								case "sel_effect": if(s.Effects.Count > 0) sr.add(s); break;
								case "sel_noeffect": if(s.Effects.Count == 0) sr.add(s); break;
								case "sel_power": if(s.PowerClip) sr.add(s); break;
								case "sel_nopower": if(!s.PowerClip) sr.add(s); break;
								case "sel_delete": s.Delete(); break;
								case "make_punktir": sr.Add(dos_punktir(s,punkt_dash,punkt_gap,radio_punktir_size.checked,ch_punkt_trim.checked,ch_punkt_del.checked,ch_punkt_join.checked,ch_punkt_line.checked)); break;
								case "make_contur": if(s.Effects.Count==0) sr.Add(dos_contur(s,param[0],param[1],param[2],param[3],param[4],param[5],param[6],param[7])); break;
								case "make_sizes": if (shft==6 && s.Type==14) s.Delete(); break;
								case "rotate": sr.Add(dos_rotate(s,mang,param,ch_rotate_rel.checked)); break;
								case "repeat_last": s.CreateSelection(); host.ActiveDocument.Repeat(); sr.add(s); break;
								case "rotate_center": 
									sadd = false;
									if (s!=glst && shft!=2) {
										if(ch_sett_center.checked){
											sx = glst.CenterX;
											sy = glst.CenterY;
										}else{
											sx = glst.RotationCenterX;
											sy = glst.RotationCenterY;
										}
										sadd = true;
									}else if(shft==2){
										sx = s.centerX;
										sy = s.centerY;
										sadd = true;
									}
									if (sadd){
										s.SetRotationCenter(sx,sy); 
										sr.Add(s); 
									}

								break;
								case "break_effect": 
									if(s.Effects.Count>0){
										if (s.Effects(1).Type==9){/*check Lens*/
											s = s.ConvertToBitmapEx();
										}else{
											spr = s.Effects(1).Separate()(1);									
											sr.Add(s);
											sr.Add(spr);
										}
									}
								break;
								case "perimetr_set_size":
									if (s.Shapes.Count==0){
										//siz = lst_per;
										if (isLastGl){
											siz  = lst_per;
										}else{
											siz  = vall(val_perimetr.value);
										}
										coef = siz/s.DisplayCurve.Length;
										s.SetSize (s.SizeWidth*coef, s.SizeHeight*coef);
										do_save(val_perimetr);
										sr.add(s);
									}
								break;
								case "all_split":
									if(s.Effects.Count>0){
										sr.AddRange (s.Effects(1).Separate);
									}else if(s.PowerClip){
										sr.AddRange(s.PowerClip.ExtractShapes());
									}else{
										var rnd = getRandom(999999,100000,0);
										var nm = rnd + s.name;
										s.name = nm;
										s.BreakApart();
										sr.AddRange(host.ActivePage.Shapes.FindShapes(nm));
									}
								break;
								case "select_no_colors":
								case "select_colors":
		var Fallos = (name=="select_colors") ? false : true;
		var add = Fallos;
		var addo = Fallos;
		var addf = Fallos;
		var addt = Fallos;
		if(s.Type==7) {
			for (var key in param[3]) if (param[3][key] == 40) add = !Fallos;
		}else if(s.Type==5){
			for(var key in param[3]) if (get_bitmap_mode(s.Bitmap.Mode)==param[3][key]) add = !Fallos;
		}else if(s.PowerClip){
			for(var key in param[3]) if (param[3][key]=='pwr') add = !Fallos;
		}else if(s.Effects.Count==1){
			for(var key in param[3]) if (50+s.Effects(1).Type==param[3][key]) add = !Fallos;
		}else if(isSimpleShape(s) && s.Effects.Count==0){
			for(var key in param[0]) if ((s.Outline.Type > 0 && s.Outline.Color.HexValue == param[0][key]) || (s.Outline.Type == 0 && param[0][key] == 0)) addo = !Fallos;
			for(var key in param[1]) if ((s.Fill.Type == 1 && s.Fill.UniformColor.HexValue == param[1][key]) || (s.Fill.Type == 0 && param[1][key] == 0)) addf = !Fallos;
			for (var key in param[4]) if(s.Type==6) if (s.Text.Story.Font == param[4][key]) addt = !Fallos;
			if(shft==4 || shft==5){
				cnt_out=param[0].length;
				cnt_fil=param[1].length;
				cnt_txt=param[4].length;
				if (cnt_txt>0){
					add = ((cnt_out>0 && addo && cnt_fil>0 && addf) || (cnt_out>0 && addo && cnt_fil==0) || (cnt_out==0 && cnt_fil>0 && addf) || (cnt_out==0 && cnt_fil==0)) && addt;
				}else{
					add = addf && addo;
				}
			}else{
				add = addt || addo || addf;
			}
			for(var key in param[2]) {
				skey = param[2][key].split(":");
				if (s.Fill.Type==2 && s.Fill.Fountain.Colors(0).Color.HexValue==skey[0] && s.Fill.Fountain.Colors(1).Color.HexValue==skey[1]) add = !Fallos;
			}
		}
		if(add) sr.add(s);
								break;
/*								case "select_no_colors":
									if(isSimpleShape(s)  && s.Type!=7){
										add = true;
										for(var key in param[0]){if ((s.Outline.Type>0 && (s.Outline.Color.HexValue!=key || key==0)) || (s.Outline.Type==0 && key!=0)){add = true;}}
										for(var key in param[1]){if ((s.Fill.Type>0 && (s.Fill.UniformColor.HexValue!=key || key==0)) || (s.Fill.Type==0 && key!=0)){add = true;}}
										if(add) sr.add(s);
									}
								break;
*/								
								case "numerate":
									if (s.type==6){
										str= false;
										nums = add_leads(num_cnt, num_digs, 0);
										tmpstr = s.text.story.text;
										if(isCtrl(shft)){
											if (tmpstr.indexOf(num_templ) >= 0) str = replaceAll(tmpstr, num_templ, nums);
										}else{
											if(tmpstr == num_templ) str = nums;
										}
										if(str){
											s.text.story.text = str;
											num_cnt += num_step;
											sr.add(s);
										}
									}
								break;
								case "round":
									var arr_sel = [];
									var arr_smart = [];

									var bynode = false;
									if (s.Type==3){
										var maxx = s.LeftX;
										var minx = s.RightX;
										var maxy = s.BottomY;
										var miny = s.TopY;
										var selcnt=0;
										for(var i=1;i<=s.Curve.Nodes.Count;i++){
											nn = s.Curve.Nodes(i);
											if(nn.PrevSegment && nn.NextSegment && ch_cont_smart.checked){
												if (Math.abs(nn.PositionX - maxx) < 1 || Math.abs(nn.PositionX - minx) < 1 || Math.abs(nn.PositionY - maxy) < 1 || Math.abs(nn.PositionY - miny) < 1){
													arr_smart.push(i);
													bynode = true;
													if (nn.Selected) {
														arr_sel.push(i);
													}
												}
											}else if (nn.Selected){
												arr_sel.push(i);
												bynode = true;
											}
										}
									}
									if (bynode){
										nr = s.Curve.Nodes.Range(1);
										nr.RemoveAll();
										if(ch_cont_smart.checked && arr_sel.length==0) arr_sel = arr_smart;
										for (var key in arr_sel){
											nr.AddRange(s.Curve.Nodes.Range(arr_sel[key]));
										}
										nr.Fillet(param); 
									}else{
										s.Fillet(param); 
									}
									sr.add(s);
								break;
								case "master_select":
									if(mlst){
										gap = 0.01;
										if (ch_master_sel_h.checked && !ch_master_sel_w.checked){
											scomp = s.SizeHeight;
											mcomp = mlst.SizeHeight;
										}else if (!ch_master_sel_h.checked && ch_master_sel_w.checked){
											scomp = s.SizeWidth;
											mcomp = mlst.SizeWidth;
										}else{
											scomp = s.SizeHeight * s.SizeWidth;
											mcomp = mlst.SizeHeight * mlst.SizeWidth;
											if (mlst.DisplayCurve && s.DisplayCurve){
												if(mlst.DisplayCurve.closed && s.DisplayCurve.closed){
													scomp = maxSPArea(s);
													mcomp = masterArea;
													gap = 0.1;
												}else if(!mlst.DisplayCurve.closed && !s.DisplayCurve.closed){
													scomp = s.DisplayCurve.length;
													mcomp = mlst.DisplayCurve.length;
												}
											}
										}
										if (shft==2 || shft==3){
											less = (radio_master_sel_l.checked) ? scomp<=mcomp : true;
											more = (radio_master_sel_m.checked) ? scomp>=mcomp : true;
										}else{
											less = (radio_master_sel_l.checked) ? scomp<mcomp : true;
											more = (radio_master_sel_m.checked) ? scomp>mcomp : true;
										}
										if(shft==4)
											equal = (radio_master_sel_e.checked) ? scomp==mcomp : true;
										else
											equal = (radio_master_sel_e.checked) ? Math.abs(scomp-mcomp)<gap : true;
										if(less && more && equal) sr.Add(s);
									}
								break;					
								case "set_sizes":
									if (ch_sizes_rotate.checked && s.Shapes.Count==0){
										ang = max_ang(s);
										s.Rotate(-ang);	
									}	
									
									swi = s.SizeWidth;
									shi = s.SizeHeight;
									wi = (isLastGl) ? mlst.SizeWidth : vall(val_sizes_wi.value);
									hi = (isLastGl) ? mlst.SizeHeight : vall(val_sizes_hi.value);
									
									if (isLastGl && ch_master_sel_h.checked && !ch_master_sel_w.checked){
										wi=0;
									}else if (isLastGl && !ch_master_sel_h.checked && ch_master_sel_w.checked){
										hi=0;
									}

									wi2 = wi;
									hi2 = hi;
									
									
									fstwi = val_sizes_wi.value.substring(0,1);
									fsthi = val_sizes_hi.value.substring(0,1);
									
									if (fstwi == "+" || fstwi == "-") wi2 = swi + wi;
									if (fsthi == "+" || fsthi == "-") hi2 = shi + hi;
									
									if (wi == 0) wi2 = swi;
									if (hi == 0) hi2 = shi;

									if (hi == 0 && ch_sizes_aspect.checked) hi2 = shi * wi2 / swi;
									if (wi == 0 && ch_sizes_aspect.checked) wi2 = swi * hi2 / shi;
									s.SetSize (vall(wi2), vall(hi2));

									if (ch_sizes_rotate.checked && s.Shapes.Count==0) s.Rotate(ang);	
									sr.Add(s);
								break;
								case "freza": 
									cnt_sp = s.DisplayCurve.SubPaths.Count;
									for(var i=1;i<=cnt_sp;i++){
										var arr_sel = [];
										sp = s.DisplayCurve.SubPaths(i);       
										for(var n=1;n<=sp.Nodes.Count;n++){
											nd = sp.Nodes(n);
											nX = nd.PositionX;
											nY = nd.PositionY;
											tang = nd.Segment.EndingControlPointAngle;
											nang = nd.Segment.Next().StartingControlPointAngle;
											if(sp.IsClockwise && sp.SizeHeight == s.SizeHeight && sp.SizeWidth == s.SizeWidth || !sp.IsClockwise && cnt_sp > 1 && (sp.SizeHeight < s.SizeHeight || sp.SizeWidth < s.SizeWidth)){
												ta = tang;
												na = nang;
											}else{
												ta = nang;
												na = tang;
											}
											
											if (param=="in"){
												ta = ta + na;
												na = ta - na;
												ta = ta - na;
											}
												
											ang = ta - na;
											if (ang < 0) ang = ang + 360;
											if (ang < 180 && nd.Segment.length > freza_Rk && nd.Segment.Next().length > freza_Rk){
												if(shft == 2 || shft==3){
													ci = host.ActiveLayer.CreateEllipse2(nX, nY, freza_R);
													sr.Add(ci);
												}else if(ch_freza_corners.checked){
													arr_sel.push(nd.AbsoluteIndex);
												}else{
													lin = host.ActiveLayer.CreateLineSegment(nX, nY, nX + freza_R, nY);
													lin.SetRotationCenter(nX, nY);
													if(ta < na) ta = ta + 360;
													if(inp){
														if (Math.abs(nd.Segment.Length-vall(inp))<0.5)
															ang = tang;
														else if (Math.abs(nd.Segment.Next().Length-vall(inp))<0.5)
															ang = nang;
													}else{
														ang = (ta + na) / 2;
													}
													lin.RotationAngle = ang;
													ci = host.ActiveLayer.CreateEllipse2(lin.Curve.Nodes.Last.PositionX, lin.Curve.Nodes.Last.PositionY, freza_R);
													sr.Add(ci);
													lin.Delete();
												}

											}
										}
										nr = sp.Nodes.Range(1);
										nr.RemoveAll();
										for (var key in arr_sel){
											nr.AddRange(s.Curve.Nodes.Range(arr_sel[key]));
										}
										nr.Fillet(freza_R); 
										
									}
								break;
								
								case "cureinvert":
									s.ConvertToCurves();
									var maxsp = 0;
									for(var i=1;i<=s.Curve.SubPaths.Count;i++){
										var sp = s.Curve.SubPaths(i);
										if (maxsp < sp.Area){
											var sp_max = sp.IsClockwise;
											maxsp = sp.Area;
										}
									}
									for(var i=1;i<=s.Curve.SubPaths.Count;i++){
										var sp = s.Curve.SubPaths(i);
										var icnt = 0;
										for(var ii=1;ii<=s.Curve.SubPaths.Count;ii++){
											var spp = s.Curve.SubPaths(ii);
											px = sp.FirstSegment.StartNode.PositionX;
											py = sp.FirstSegment.StartNode.PositionY;
											if (spp.IsPointInside(px, py)) icnt++;
										}
										if (icnt % 2 > 0 && sp.IsClockwise == sp_max)
											sp.ReverseDirection();
										else if (icnt % 2 == 0 && sp.IsClockwise != sp_max)
											sp.ReverseDirection();
									}
								break;
								
								
								case "fefco":
									cx = s.CenterX;
									cy = s.CenterY;
									fwi = s.SizeWidth;
									fle = s.SizeHeight;
									mode="";
									lx=cx;
									ly=cy;
									for (var key in ffile){
										//line = ffile[key].split("=");
										line = ffile[key].split("=");
										lncnt = line.length;
										if(lncnt==1){
											mode = line[0];
										}else{
											for (var kl in line){
												var ln = line[kl].split(":");
												lcnt = ln.length;
												sum = 0;
												lm = false;
												rel = true;
												ss="";
												for (var k=0;k<lcnt;k+=2){
													var t = ln[k];
													var v = ln[k+1];
													if(t.substring(0,2)=="LM"){lm="OK"; t = t.substring(2);}
													switch (t){
														case "W": t = fwi; break;
														case "L": t = fle; break;
														case "H": t = fhi; break;
														case "T": t = fth; break;
														case "CX": t = cx; rel = false; break;
														case "CY": t = cy; rel = false; break;
														case "LX": t = lx; rel = false; break;
														case "LY": t = ly; rel = false; break;
													}
													if (t=="SV" || t=="SH") ss = t+":"+v; else if (lm=="OK") lm = t*v; else sum += t*v;
												}
												if(lm){
													relsum = 0;
													
													if(!rel) relsum = (kl % 2 == 0) ? lx : ly;
													sum -= relsum;
													dir = (sum<0) ? -1 : 1;
													if (Math.abs(sum)>lm) sum = lm*dir;
													sum += relsum;
												}
												if (ss.length>0) sum = ss +":"+ sum;
												line[kl] = sum;
												if (kl!=2 || lncnt!=3){ if (kl % 2 == 0) lx = sum; else ly = sum;}
											}
										}
										switch (mode){
											case "out":
												if (lncnt==4){
													lout = host.ActiveLayer.CreateLineSegment(line[0],line[1],line[2],line[3]);
												}else if (lncnt>1){
													if(line.length>2){
														if (line[2]>0){
															lout.Curve.SubPaths.Last.AppendLineSegment(line[0],line[1]);
															lout.Curve.Nodes.Last.Previous().Fillet(line[2]);
														}else{
															qty = line[2].split(":");
															siz = qty[2]/(3*qty[1]);
															dir = (siz<0) ? -1 : 1;
															if(qty[0]=="SH"){
																sx = line[0]-qty[2];
																lout.Curve.SubPaths.Last.AppendLineSegment(sx+siz,line[1]);
																lout.Curve.SubPaths.Last.AppendLineSegment(sx+siz+dir*fth*0.25,line[1]+dir*fth*1.5);
																if(fwi>111){
																	lout.Curve.SubPaths.Last.AppendLineSegment(sx+2*siz-dir*fth*0.25,line[1]+dir*fth*1.5);
																	lout.Curve.SubPaths.Last.AppendLineSegment(sx+siz*2,line[1]);
																}else{
																	line[1]+=+dir*fth*1.5;
																}
																if(qty[1]==2){
																}
																
															}else if(qty[0]=="SV"){
																
															}
															lout.Curve.SubPaths.Last.AppendLineSegment(line[0],line[1]);
														}
													}else{
														lout.Curve.SubPaths.Last.AppendLineSegment(line[0],line[1]);
													}
												}
											break;
										}
									}
								break;
							}
						}
						if (s!=mlst && mlst){
							switch (name){
								case "master_replace":
									dup = mlst.Duplicate();
									if(ch_master_byends.checked && s.Shapes.Count==0){
										for(var k=1;k<=s.DisplayCurve.Nodes.Count;k++){
											nd = s.DisplayCurve.Nodes(k);
											if(nd.IsEnding){
												moveC(dup, nd.PositionX, nd.PositionY);
												if (ch_master_rotate.checked){
													dup.RotationAngle = (nd.NextSegment) ? nd.NextSegment.EndingControlPointAngle : nd.PrevSegment.StartingControlPointAngle;
												}
												dup = mlst.Duplicate();
											}
										}
										dup.Delete();
									}else{
										if (ch_master_rotate.checked){
											sang = max_ang(s);
											dup.RotationAngle = (shft==4 || shft==5) ? sang-max_ang(dup,false) : sang;
										}
										if (ch_master_size.checked) {
											koef = 0;
											if (ch_master_sel_w.checked && !ch_master_sel_h.checked){
												koef = (s.DisplayCurve.Closed) ? s.SizeHeight/dup.SizeHeight : s.DisplayCurve.length/dup.SizeHeight;
											}else if (ch_master_sel_h.checked && !ch_master_sel_w.checked){
												koef = (s.DisplayCurve.Closed) ? s.SizeWidth/dup.SizeWidth : s.DisplayCurve.length/dup.SizeWidth;
											}
										
											if(koef>0){
												dup.SizeWidth = dup.SizeWidth*koef;
												dup.SizeHeight = dup.SizeHeight*koef;
											}else{
												dup.SizeWidth = s.SizeWidth;
												dup.SizeHeight = s.SizeHeight;
											}
										}
									}
									moveC(dup, s.RotationCenterX, s.RotationCenterY);
									dup.OrderFrontOf(s);	
									sr.Add(dup);
									if (ch_master_del.checked) s.Delete();
								break;
							}
						}
					}
				}
				
				switch(name){
					case "numerate": val_num_start.value = num_cnt; do_save(val_num_start); break;
				}
				
				host.ActiveDocument.ClearSelection();
			}else{
				//sr.AddRange(OS);
			}
			if (name!="repeat_last") do_end(undogroup);
		}
		return sr;
	}else{
		return 	getEOS();
	}
}

function dos_contur(s,size,dir,split,todel,round,reduce,cut,smart){
	if (dir=="in") dir = 0;
	if (dir=="out") dir = 1;
	if(split === undefined) split = true;
	if(todel === undefined) todel = true;
	if(round === undefined) round = true;
	if(reduce === undefined) reduce = false;
	if(cut === undefined) cut = false;
	if(smart === undefined) smart = false;
	
	if (smart){
		size = size / 2;
		dir = 1;
	}
	if(round){
		s.CreateContour(dir, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 1, 2);
	}else{
		s.CreateContour(dir, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 2, 4, 15);
	}
	if(s.Effects.Count > 0 && split){
		spr = s.Effects(1).Separate()(1);
		
		if (smart && s.DisplayCurve.Closed){
			if(round){
				s.CreateContour(0, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 1, 2);
			}else{
				s.CreateContour(0, size, 1, 0, s.Outline.Color, s.Fill.UniformColor, s.Fill.UniformColor, 0, 0, 2, 4, 15);
			}
			if(s.Effects.Count > 0) spr = s.Effects(1).Separate()(1).Trim(spr, false);
		}
		if(reduce && spr.Type==3) spr.Curve.AutoReduceNodes(2);
		if(spr.Fill && ch_cont_nofil.checked) spr.Fill.ApplyNoFill();
		if (cut) spr = (dir==1) ? s.Trim(spr,true) : spr.Trim(s,false,true);
		if(s.PowerClip==null){
			if (s.name!="") spr.name = s.name;
			if (todel) s.Delete();
			s = spr;
		}else{
			s.ConvertToCurves();
			if (todel){
				s.Curve.CopyAssign(spr.Curve);
				spr.Delete();
			}
		}				
	}
	return s;
}

function dos_rotate(s, ang, param, rotate_rel){
	if(param === undefined) param = 0;
	if(rotate_rel === undefined) rotate_rel = true;	
	shft = Shift();
	if (param=="long"){
		s.Rotate(-max_ang(s,false));
	}else if (param=="ang"){
		if(shft>0) s.Rotate(ang); else s.Rotate(-ang);
	}else{
		if(isCtrl(shft)) s = s.Duplicate();
		if(rotate_rel) s.Rotate(ang); else  s.RotationAngle = ang; 
	}
	return s;
}

function dos_punktir(s,punkt_dash,punkt_gap,punkt_size,punkt_trim,punkt_del,punkt_join,punkt_line){
	if(punkt_gap === undefined) punkt_gap = 0;
	if(punkt_size === undefined) punkt_size = true;
	if(punkt_trim === undefined) punkt_trim = false;
	if(punkt_del === undefined) punkt_del = true;
	if(punkt_join === undefined) punkt_join = true;
	if(punkt_line === undefined) punkt_line = false;	
	
	s.ConvertToCurves();
	ss = s.BreakApartEx();
	var srp = host.ActiveSelectionRange;
	srp.RemoveAll();

	var cnt_sps = ss.Count;
	for(var i=1;i<=cnt_sps;i++){
		ssp = ss(i);
		sp = ssp.Curve.Subpaths(1);
		sp_len = sp.length;
		if(punkt_trim) sp = sub_trim(sp,punkt_gap);
		
		if(punkt_dash>0){

			dashs = (punkt_size) ? (sp_len - punkt_dash) / (punkt_dash + punkt_gap) : punkt_dash;
			sp.EqualDivide (getRound(dashs,0), punkt_gap);
			var todel = [];
			bynode = false;
			if(punkt_del){
				for(var n=1;n<=ssp.Curve.Nodes.Count;n++){
					if (!ssp.Curve.Nodes(n).IsEnding){
						todel.push(n);
						bynode = true;
					}
				}
				if (bynode){
					nr = ssp.Curve.Nodes.Range(1);
					nr.RemoveAll();
					for (var key in todel){
						nr.AddRange(ssp.Curve.Nodes.Range(todel[key]));
					}
					nr.Delete(); 
				}
				
			}
			
			if(punkt_line){
				for(var n=1;n<=ssp.Curve.Segments.Count;n++){
					seg = ssp.Curve.Segments(n);
					if(seg.Type > 0) seg.Type = 0;
				}
			}
		}
		srp.Add(ssp);
	}
	if (srp.Shapes.Count>1) s = srp.Combine();
	if(punkt_join) s.CustomCommand ("ConvertTo", "JoinCurves", punkt_gap + 0.1);	
	return s;
}

function calc_fast(){
	if(in_main) {
		if( host.ActiveShape != null ){
			shft = Shift();
			sel_cnt = host.ActiveSelection.Shapes.Count;
			if (sel_cnt>0){
				allen=0;
				alarea=0;
				OS = get_OS();
				
				for(var i=1;i<=OS.Shapes.Count;i++) alarea += one_shape_area(OS.Shapes(i),ch_calc_external.checked);
				
				allen = all_shapes_len(OS) * wScale;
				alarea *= wScale;
				if(radio_calc_m.checked){
					allen /= 1000;
					alarea /= 1000000;
				}else if(radio_calc_cm.checked){
					allen /= 10;
					alarea /= 100;
				}
				
				var clen = allen * vall(val_calc_len_price.value,false);
				calc_len_len.value = getRound(allen,4);
				calc_len_cost.value = getRound(clen,3);
				do_save(val_calc_len_price);
				
				var carea = alarea * vall(val_calc_area_price.value,false);
				calc_area_area.value = getRound(alarea,4);
				calc_area_cost.value = getRound(carea,3);
				calc_area_total.value = getRound((carea + clen) * calc_area_colvo.value*1 ,3);
				do_save(val_calc_area_price);
			}
		}
	}
}
/*
function all_shapes_area(ss, external){
    all_area = 0
    For Each s In ss
        If s.Shapes.Count > 0 Then
            all_area = all_shapes_area(s.Shapes, units, external)
        Else
            all_area = all_area + one_shape_area(s, units, external)
        End If
    Next s
    all_shapes_area = all_area
}*/

function moveC(s, X, Y, dupl, center){
	if(X === undefined) X = host.ActiveDocument.ActiveWindow.ActiveView.OriginX;
	if(Y === undefined) Y = host.ActiveDocument.ActiveWindow.ActiveView.OriginY;
	if(dupl === undefined) dupl = false;
	if(center === undefined) center = (ch_sett_center.checked) ? "C" : "R";
	switch (center){
		case "TL": dx = X - s.LeftX; dy = Y - s.TopY; break;
		case "TC": dx = X - s.CenterX; dy = Y - s.TopY; break;
		case "TR": dx = X - s.RightX; dy = Y - s.TopY; break;
		case "CL" : dx = X - s.LeftX; dy = Y - s.CenterY; break;
		case "C" : dx = X - s.CenterX; dy = Y - s.CenterY; break;
		case "CR" : dx = X - s.RightX; dy = Y - s.CenterY; break;
		case "BL": dx = X - s.LeftX; dy = Y - s.BottomY; break;
		case "BC": dx = X - s.CenterX; dy = Y - s.BottomY; break;
		case "BR": dx = X - s.RightX; dy = Y - s.BottomY; break;
		default  : dx = X - s.RotationCenterX; dy = Y - s.RotationCenterY; break;
	}
	if (dupl){
		return s.Duplicate(dx, dy); 
	}else{
		s.Move(dx, dy);
		return s;
	}
}

function all_shapes_len(OS){
	var oss = getInGroup(os);
	var allen = 0;
	for(var i=1;i<=oss.Shapes.Count;i++){
		s = oss.Shapes(i);
		if(s.DisplayCurve!==undefined && s.DisplayCurve!==null){
			allen += s.DisplayCurve.Length;
		}
	}
	return allen;
}

function one_shape_area(s,external){
	if(external === undefined) external = false;
	all_area = 0;
    if (external || s.Shapes.Count>0){
        all_area = s.SizeHeight * s.SizeWidth;
    }else{
        if (s.Shapes.Count==0){if (s.DisplayCurve){if(s.DisplayCurve.closed){
            s_info = get_subpath_info(s);
            all_area = 0;
			for (var cns=1;cns<=s.DisplayCurve.SubPaths.Count;cns++){
				sp  = s.DisplayCurve.SubPaths(cns);
                all_area = (s_info[cns][3] % 2 == 0 ) ? all_area + sp.Area : all_area - sp.Area;
			}
		}}}
	}
    return all_area;
}


function get_subpath_info(one_shape){
    var sup = [];
    
	if (one_shape.Shapes.Count==0){if(one_shape.DisplayCurve){
		sp_cnt = one_shape.DisplayCurve.SubPaths.Count;
		for (var cns=1;cns<=sp_cnt;cns++){
			sp  = one_shape.DisplayCurve.SubPaths(cns);
			sup[cns] = [cns, sp.Nodes.First.PositionX, sp.Nodes.First.PositionY,0,sp.BoundingBox.Left, sp.BoundingBox.Right, sp.BoundingBox.Top,sp.BoundingBox.Bottom];
		}
		maxc = 0;
		for (var i=1;i<=sp_cnt;i++){
			for (var cns=1;cns<=sp_cnt;cns++){
				if(i!=cns){
					sp  = one_shape.DisplayCurve.SubPaths(cns);
					if (sp.BoundingBox.Left < sup[i][5]){
						if (sp.BoundingBox.Right > sup[i][4]){
							if (sp.BoundingBox.Top > sup[i][7]){
								if (sp.BoundingBox.Bottom < sup[i][6]){
									res = sp.IsOnSubPath(sup[i][1],sup[i][2]);
									if (res == 2) sup[i][3]++
								}
							}
						}
					}
				}
			}
		}
	}}
    return sup;
}

function GetShapesInfo(){
	if(host.Activeshape){
		numSelected.value = get_OS().Shapes.Count;
		objectName = host.Activeshape.Evaluate("@type"); // use CQL to get the object type name
		selectedObject.value = objectName;
		wi = host.ActiveShape.SizeWidth;
		hi = host.ActiveShape.SizeHeight;
		info_wi.value = wi*wScale;
		info_hi.value = hi*wScale;
		dd = info_del.value;
		val = vall(dd.substring(1),false);
		switch (dd.substring(0,1)){
			case "/": wid = wi/val; hid=hi/val; break;
			case "*": wid = wi*val; hid=hi*val; break;
			case "-": wid = wi-val; hid=hi-val; break;
			default: wid = wi+val; hid=hi+val; break;
		}
		info_wid.value = vall(wid*wScale,false,4);
		info_hid.value = vall(hid*wScale,false,4);
	}
}


function getStrfromCurve(crv){
	/*Добавить подпути в парсер*/
	var vals = "";
	for (var si=1;si<=crv.SubPaths.Count;si++){
		sp = crv.SubPaths(si);
		vals += sp.Nodes(1).PositionX + ":" + sp.Nodes(1).PositionY + chr(10);
		nds_cnt = sp.Nodes.Count;
		nds = (sp.Closed) ? nds_cnt+1 : nds_cnt;
		for (var i=2;i<=nds;i++){
			nd = (i>nds_cnt) ? sp.Nodes(1) : sp.Nodes(i);
			vals += nd.PositionX + ":" + nd.PositionY + ":";
			if(nd.PrevSegment.Type > 0 /*cdrLineSegment*/) vals += nd.PrevSegment.StartingControlPointX + ":" + nd.PrevSegment.StartingControlPointY + ":" + nd.PrevSegment.EndingControlPointX + ":" + nd.PrevSegment.EndingControlPointY;
			if (i>nds_cnt) vals += ":13.13";
			vals += chr(10);
		}	
	}
	vbWriteFile(host.UserDataPath + "ar_envel.txt", vals);
	return vals;
}

function getCurvefromStr(str){
	/*Добавить подпути в парсер*/
	var crv = false;
	var pts = str.split(chr(10));
	if(pts.length>2){
		var crv = host.ActiveDocument.CreateCurve();
		sp = false;
		for (var p=0;p<pts.length;p++){
			pt = pts[p].split(":");
			for(var i=0;i<pt.length;i++) pt[i]*=1;
			//alert(pt.length);
			if(pt.length>1){
				//alert(pt[3] + ":" + pt[6]);
				if(pt.length==2){
					sp = crv.CreateSubPath(pt[0], pt[1]);
				}else if(pt.length>4){
					sp.AppendCurveSegment2(pt[0],pt[1],pt[2],pt[3],pt[4],pt[5]);
					if (pt[6]==13.13) crv.JoinTouchingSubpaths();
				}else{
					//alert(pt.length);
					sp.AppendLineSegment(pt[0], pt[1]);
					if (pt[3]==13.13) crv.JoinTouchingSubpaths();
				}
			}
		}
		//crv.JoinTouchingSubpaths();
	}
	return crv;
}

function show_help(el){
	elid = el.id;
	if (elid.substr(0,4)=="img_") elid = elid.substr(4);
	if (hint[elid]){
		hints = (hint[elid]);
		adds = CR + CR + CR;
	}else{
		hints = "";
		adds = "";
	}

	descr = (desc[elid]) ? hints + adds + desc[elid] : hints;
	//alert(elid + "=" + descr.length + ":" + hint + "----" + descr);
	if (descr.length>3){
		if (utub[elid]){
			if(confirm(descr + CR + CR + CR + lang['text_youtube'])){
				//window.open('https://youtu.be/' + utub[elid]);
				vbOpenFolder(utub[elid]);
			}
		}else{
			alert(descr);
		}
	}
	return false;
}



function FindShapes(lay, name, strong){
	if(strong === undefined) strong = true;	
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
		
	for (var i=1;i<=lay.Shapes.Count;i++){
		var s = lay.Shapes(i);
		if(strong){
			nm = s.name;
			if (nm==name || nm.toLowerCase() == name.toLowerCase() || nm.toUpperCase() == name.toUpperCase()) sr.Add(s);
		}else{
			ind = s.name.indexOf(name);
			if (ind>-1) sr.Add(s);
		}
	}
	return sr;
}

function FindIn(shape, gap, touch, type){
	if(gap === undefined) gap = 0;	
	if(touch === undefined) touch = false;	
	return host.ActivePage.SelectShapesFromRectangle(shape.leftx-gap, shape.bottomy-gap, shape.rightx+gap, shape.topy+gap, touch).Shapes.All();
}	
/*
	if(type === undefined) type = "square";	
	var srAll = host.ActiveSelectionRange;
	srAll.RemoveAll();
	if(shape){
		rx = shape.rightx;
		lx = shape.leftx;
		ty = shape.topy;
		by = shape.bottomy;			
		var page = host.ActivePage;
		for(var i=1;i<=page.Shapes.Count;i++){
			s = page.Shapes(i);
			insq = false;
			if(touch){
				if(s.leftx<=rx+gap) if(s.topy>=by-gap) if(s.bottomy<=ty+gap) if(s.rightx>=lx-gap) insq = true;
			}else{
				if(s.leftx>=lx-gap) if(s.topy<=ty+gap) if(s.bottomy>=by-gap) if(s.rightx<=rx+gap) insq = true;
			}
			if(insq){
				switch(type){
					case "square": srAll.Add(s); break;
				}
			}
		}
	}
	return srAll;*/


function ShapesUnlock(OS, undogroup){
	if(undogroup === undefined) undogroup = true;	
	if(OS === undefined) OS = get_OS();	
	do_begin("unlock all", undogroup, glOptim);
	for(var i=1;i<=OS.Shapes.Count;i++){
		OS.Shapes(i).locked = false;
	}
	do_end(undogroup);
	return OS;
}

function FindSegXY(glx, gly, sel){
	fnd = false;
	for(var i=1;i<=sel.Shapes.Count;i++){
		sa = sel.Shapes(i);
        if (sa.DisplayCurve){
            sfnd = sa.Curve.FindSegmentAtPoint(glx, gly, 0, 1);
            if(sfnd) {
				return sfnd;
			}
        }else{
            fnd = FindSegXY(glx, gly, sa);
        }
    }
    return sel.FirstShape.Curve.Segments(1);
}


function max_ang(s, check_ang){
	if(check_ang === undefined) check_ang = true;
	ang = 0;
	if (s){
		if (check_ang && s.RotationAngle!=0 || !isSimpleShape(s)) {
			ang  = s.RotationAngle;
		}
		if (ang==0 && s.Shapes.Count==0 && isSimpleShape(s)){
			max = 0;
			imax = 0;
			for(var k=1;k<=s.DisplayCurve.Segments.Count;k++){
				len = s.DisplayCurve.Segments(k).Length;
				if (len>max){
					max = len;
					imax = k;
				}
			}
			ang = s.DisplayCurve.Segments(imax).EndingControlPointAngle;	
		}
	}
	return ang;
}

function max_area(OS){
	if(OS === undefined) OS = get_OS();
	max = 0;
	smax = OS.FirstShape;

	cnt_os = OS.Shapes.Count;
	for(var i=1;i<=cnt_os;i++){
		s = OS.Shapes(i);
		area = s.SizeWidth * s.SizeHeight;
		if (area>max){
			max = area;
			smax = s;
		}
	}	
	return smax;
}

function max_size(s){
	max = s.SizeWidth;
	if (s.SizeHeight>max) max = s.SizeHeight;
	return max;
}

function lastSize(lst, perimetr){
	if(perimetr === undefined) perimetr = false
	siz = 0;
	if(isSimpleShape(lst)){
		clsd = true;
		if(lst.DisplayCurve) if(!lst.DisplayCurve.closed) clsd = false;
		if(clsd){
			if (ch_master_sel_h.checked && !ch_master_sel_w.checked){
				siz = lst.SizeHeight;
			}else if (!ch_master_sel_h.checked && ch_master_sel_w.checked){
				siz = lst.SizeWidth;
			}else{
				siz = (perimetr && lst.Shapes.Count==0) ? lst.DisplayCurve.Length :  max_size(lst);
			}
		}else{
			siz = lst.DisplayCurve.length;
		}
	}
	return siz;
}


function maxSPArea(s){
	area = 0;
	if (s){
		max = 0;
		for(var k=1;k<=s.DisplayCurve.SubPaths.Count;k++){
			sp = s.DisplayCurve.SubPaths(k);
			if(sp.closed){
				are = sp.Area;
				if (are>max) max = are;
			}
		}
		area = max;
	}
	return area;
}


function sub_trim(spp, gap){
	shft = Shift();
	if(spp.closed && shft==2) spp.Nodes.First.BreakApart();
	if(!spp.closed){
		spp.AddNodeAt(gap, 0);
		spp.AddNodeAt(spp.length - gap, 0);
		spp.Nodes.First.Delete();
		spp.Nodes.Last.Delete();
	}	
	return spp;
}

function getRef(setDoc){
	if(setDoc === undefined) setDoc = true;
	s = host.ActiveLayer.CreateEllipse2(0,0,100);
	sx = s.CenterX;
	sy = s.CenterY;
	host.FrameWork.Automation.InvokeItem("e6644135-9dab-4935-8ab9-fc85527810ca");
    host.FrameWork.Automation.InvokeItem("6ae897fd-2eab-4dad-b172-f4fb768c273e");
	ex = s.CenterX;
	ey = s.CenterY;
	//s.Delete();
	if(ey > sy){
		refpt = 2;
		if(ex<sx) refpt = 3;
		if(ex>sx) refpt = 1;
	}else if(ey < sy){
		refpt = 6;
		if(ex<sx) refpt = 5;
		if(ex>sx) refpt = 7;
	}else{
		refpt = 9;
		if(ex<sx) refpt = 4;
		if(ex>sx) refpt = 8;
	}

	if(setDoc) host.ActiveDocument.ReferencePoint = refpt;
	return refpt;
}

function hextorgb(hex) {
	if(hex === undefined) hex = '000';
	var arr = [0,0,0];
	if (hex.length==3)
		str = "" + hex.substring(0,1) + hex.substring(0,1) + hex.substring(1,2) + hex.substring(1,2) + hex.substring(2,3) + hex.substring(2,3);
	else if (hex.length==6)
		str = "" + hex;
	else 
		str = false;
	if (str){
		arr = [parseInt(str.substring(0,2),16),parseInt(str.substring(2,4),16),parseInt(str.substring(4,6),16)];
	}
	return arr;
}

function getRadio(name){
	check = "";
	var elems = document.getElementsByName(name);
	for (var i = 0; i < elems.length; i++){
		var el = elems[i];
		if(el.checked) break;
	}
	return el;
}

function replaceAll(str, find, replace) {
	if(find=="trim" && replace===undefined){
		return str.replace(/^\s+|\s+$/gm,'');
	}else{
		return str.replace(new RegExp(find, 'g'), replace);
	}
}

function arrwarn(arr){
	txt = "";
	for(var i=0;i<=arr.length;i++){
		if(arr[i][0]!=null){
			for(var j=0;j<=arr[i].length;j++){
				if(arr[i][j]!=null){
					txt += "arr["+i+",]["+j+"]=" + arr[i][j] + "<br>";
				}
			}
		}
	}
	return txt;
}

function circles2(x1, y1, r1, x2, y2, r2,xn,yn) {
  // Calculate the dist between the centers of the two circles
  dist = distXY(x1, y1, x2, y2);

  // Check if the two circles intersect
  if (dist <= r1 + r2 && dist >= Math.abs(r1 - r2)) {
    // Calculate the intersection points
    a = (r1*r1 - r2*r2 + dist*dist)/ (2 * dist);
    h = Math.sqrt(r1*r1 - a*a);
    x3 = x1 + (a * (x2 - x1)) / dist;
    y3 = y1 + (a * (y2 - y1)) / dist;

    if (dist == r1 + r2) {
      return [x3,y3];
    }

    x4 = x3 + (h * (y2 - y1)) / dist;
    y4 = y3 - (h * (x2 - x1)) / dist;
    x5 = x3 - (h * (y2 - y1)) / dist;
    y5 = y3 + (h * (x2 - x1)) / dist;

	if(xn != undefined && yn != undefined){
		if(Math.sqrt((x4 - n1)^2 + (y4 - yn)^2) > Math.sqrt((x5 - n1)^2 + (y5 - yn)^2)){
			return [x5,y5,x4,y4];
		}
	}
	
	return [x4,y4,x5,y5];
  }

  // If the two circles do not intersect, return an empty array
  return [];
}

function Shift(){
	ret = 0;
	if(window.event.shiftKey) ret++;
	if(window.event.ctrlKey) ret+=2;
	if(window.event.altKey) ret+=4;
	return ret;
}

function arrFindNst (arr,start,dif,field,maxh){
	var koef = 1.3
	var max = maxi = 0;
	var fnd = false;
	for(var i=start;i<=arr.length;i++){
		for(var j=i;j<=arr.length;j++){
			if(arr[i] && arr[j]){
				if (i==j) {
					var wi = arr[i][field];
					var hi = arr[i][field+1];
					var k =  (Shift()==4) ? 1 : 1.1;
				}else{
					var wi = arr[i][field]+arr[j][field] ;
					var hi = Math.max(arr[i][field+1], arr[j][field+1]);
					var k =  1;
				}
				if (wi<=dif && hi<maxh*koef){
					var delta = wi*hi*k;
					if(delta>max){
						max = delta;
						arr[i][6]=max;
						fnd = i;
					}
				}
			}
		}
	}
	return fnd;
}

function add_leads(str, digs, lead){
	str = "" + str;
	while (str.length < digs) str = "" + lead + str;
	return str;
}

function inArray(value, array) {
  for (var i = 0; i < array.length; i++) if (value === array[i]) return true;
  return false;
}

function sort2D(a,b){ if (a[0] > b[0]) return 1; if (a[0] < b[0]) return -1; return 0;}
function rsort2D(a,b){ if (a[0] < b[0]) return 1; if (a[0] > b[0]) return -1; return 0;}
function distXY(x1,y1,x2,y2){return Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));}
function isShift (shft){return (shft==1 || shft==3 || shft==5 || shft==7) ? true : false;}
function isCtrl (shft){return (shft==2 || shft==3 || shft==6 || shft==7) ? true : false;}
function isAlt (shft){return (shft>3)  ? true : false;}
function chr( ascii ) {return String.fromCharCode(ascii);}

function isLast(OS, global_master){
	if(global_master === undefined) global_master = false;
	 ret = (Shift()==7 && OS.Shapes.Count>0);
	 if (global_master) ret = (ret || (master && ch_master_sample.checked)) 
	 return ret;
}

function isSimpleShape(s, arryes){
	if(arryes === undefined) arryes = [];
	arrno = [5,7,10,11,12,13,15,16,17,18,19,20,22,23,24,25,26,27,28,29,30];
	//inArray(s.Type,[1,2,3,4,6,9,14,21])
//	return false;
	return (!inArray(s.type, arrno) || inArray(s.type, arryes)) ? true : false;
}

function isDCurve(s){
	return (s.DisplayCurve!=null && s.Type!=6) ;
}

function warn(text, alarm){
	if(alarm === undefined) alarm = true;
	
	if (text.length<2){
		warning.innerHTML = "";
		warning.style.display = "none";
	}else{
		if (ch_warn_alert.checked && alarm){
			warning.innerHTML = "";
			warning.style.display = "none";
			alert(text); 
		}else{
			text = replaceAll(text,CR,"<br />");
			warning.style.display = "block";
			warning.innerHTML = text;
		}
	}
	host.Application.Refresh();
}	

function getRandom(max, min,dig) {
	if(max === undefined) max = 10;
	if(min === undefined) min = 1;
	if(dig === undefined) dig = 4;
    min = Math.ceil(min);
    max = Math.floor(max);
    return getRound(Math.random() * (max - min + 1),dig) + min;
}
function getRound(val,dig){
	if(dig === undefined) dig = 4;
	ret = vall(val,false,-1);
	if(dig>-1){
		ret = ret.toString();
		ind = ret.indexOf(".");
		if (ind<1) ind = ret.length;
		ret = ret.substring(0,ind+dig+1);
		ret*=1;
	}
    return ret;
}

function do_begin(undoname,undogroup,optimize,units,sett){
	if(host.ActiveDocument!=null){
		if(undoname === undefined) undoname = "do somth";
		if(undogroup === undefined) undogroup = true;
		if(optimize === undefined) optimize = glOptim;
		if(units === undefined) units = 3;
		if(sett === undefined) sett = "before";
		host.ActiveDocument.SaveSettings(sett);
		host.ActiveDocument.Unit = units;
		if(undogroup) host.ActiveDocument.BeginCommandGroup(undoname);
		host.Application.Optimization = optimize;
		host.EventsEnabled = !optimize;
	}
}

function do_end(undogroup,sett){
	if(host.ActiveDocument!=null){
		if(undogroup === undefined) undogroup = true;
		if(sett === undefined) sett = "before";
		do_cure(undogroup);
		host.ActiveDocument.RestoreSettings(sett);
	}
}

function do_cure(undogroup){
	if(host.ActiveDocument!=null){
		if(undogroup === undefined) undogroup = true;
		host.EventsEnabled = true;
		host.Application.Optimization = false;
		if(undogroup) host.ActiveDocument.EndCommandGroup();
		host.Application.Refresh();
		host.ActiveWindow.Activate();	
		host.DoEvents;
		
/*
		os = get_OS();
		if (os.Shapes.Count==2){
			s1 = os.Shapes(1);
			s2 = os.Shapes(2);
			rets = circles2(s1.centerX,s1.centerY,s1.SizeWidth/2,s2.centerX,s2.centerY,s2.SizeWidth/2);
			if(rets.length>0) el1 = host.ActiveLayer.CreateEllipse2(rets[0], rets[1],10);
			if(rets.length>2) el1 = host.ActiveLayer.CreateEllipse2(rets[2], rets[3],20);
			
		}
*/		
	}
}

function get_OS(bycolor, ingroup, selall, reverse){
	warn("");
	if(defdoc()){
		if(bycolor === undefined) bycolor = true;
		if(reverse === undefined) reverse = false;
		if(selall === undefined) selall = true;
		if(ingroup === undefined) {
			shft = Shift();
			ingroup = (shft==1 || shft==3 || shft==5 || shft==7) ? true : false;
		}
		host.ActiveWindow.Activate();
		if(bycolor){
			os = select_colors();
		}else{
			os = host.ActiveSelectionRange;
			if(radio_sett_doc.checked){
				os.RemoveAll();
				for (var i=1;i<=host.ActiveDocument.Pages.Count;i++){
					os.AddRange(host.ActiveDocument.Pages(i).Shapes.All());
				}
			}else if(os.Shapes.Count==0 && selall) {
				os = host.ActivePage.Shapes.All();
				msg = lang['text_more50'].replace("{shtuk}",os.Shapes.Count);
				if (os.Shapes.Count>200) if (!confirm(msg)) os.RemoveAll();
			}
		}
		//if (ingroup) os = os.Shapes.FindShapes("", 0, ingroup, "@Name!='dsf'");
		if (ingroup) os = getInGroup(os);
		if (reverse) os = os.ReverseRange;
		return os;	
	}else{
		return getEOS();
	}
}

function getInGroup(OSS){
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	for (var i=1;i<=OSS.Shapes.Count;i++){
		var s = OSS.Shapes(i);
		if (s.Shapes.Count==1 && s.Effects.Count==0){
			sd = s.Shapes(1);
			s.Ungroup();
			s = sd;
		}
		if (s.Shapes.Count==0){
			sr.Add(s);
		}else{
			sr.AddRange(getInGroup(s.Shapes.All()));
		}
	}	
	return sr;
}

function vall(srcc, scale, round){
	var src = srcc;
	if (src!=null){
		if(round === undefined) round = -1;
		if(scale === undefined) scale = true;
		scal = (scale) ? wScale : 1;
		src = src.toString().replace(",",".");
		//src = src.parseFloat;
		src*=1;
		src = src / scal;
		if(round>-1) src = getRound(src,round);
		return src;
	}else{
		return false;
	}
}

function defdoc(){
	wScale = 1;
	ret = false;
	if(host.ActiveDocument){
		host.ActiveDocument.Unit=3;
		host.ActiveDocument.ReferencePoint = 9;
		wScale = host.ActiveDocument.WorldScale;
		ret = true;
	}	
	return ret;
}

// VBA functions

function vbWriteFile(fname, data){
	ret = host.GMSManager.RunMacro("wpanel", "Macros.WriteFile", fname, data);
	return ret;
}

function vbReadFile(name, split){
	if(split === undefined) split = "";
	ret = host.GMSManager.RunMacro("wpanel", "Macros.ReadFile", name);
	if (split.length>0) ret = (ret) ? ret.split(split) : [];
	return ret;
}
function vbReadFolder(name){
	ret = host.GMSManager.RunMacro("wpanel", "Macros.ReadFolder", name);
	ret = (ret) ? ret.split(chr(10)) : [];
	return ret;
}
function vbgetClick(){
	ret = host.GMSManager.RunMacro("wpanel", "Macros.getClick");
	ret = (ret) ? ret.split(":") : [];
	return ret;
}

function vbGetPointPositionAt(seg, off){
	ret = host.GMSManager.RunMacro("wpanel", "Macros.GetPointPositionAtXY", seg, off);
	ret = (ret) ? ret.split(":") : [];
	return ret;
}

function vbRead(name){return host.GMSManager.RunMacro("wpanel", "Macros.regR", name);}
function vbWrite(name,val){return host.GMSManager.RunMacro("wpanel", "Macros.regW", name, val);}
function vbStatSend(ver){return host.GMSManager.RunMacro("wpanel", "Macros.stat_send",ver);}
function vbgetExist(sha){return host.GMSManager.RunMacro("wpanel", "Macros.get_exist",sha);}
function vbgetSegOffbyXY(seg,xx,yy){return host.GMSManager.RunMacro("wpanel", "Macros.getSegOffbyXY", seg, xx, yy);}
function vbMakeSize(dir, shft){return host.GMSManager.RunMacro("wpanel", "Macros.make_sizes_sep", dir, shft);}
function vbOpenFolder(path){return host.GMSManager.RunMacro("wpanel", "Macros.open_folder", path);}
function vbImportFile(path){return host.GMSManager.RunMacro("wpanel", "Macros.ImportFile", path);}

function vbTemplFileAdd(path){return host.GMSManager.RunMacro("wpanel", "Macros.TemplFileAdd", path);}
function vbTemplFileDel(path, fname, title, msg){return host.GMSManager.RunMacro("wpanel", "Macros.TemplFileDel", path, fname, title, msg);}
function vbTemplCatAdd(path, title, msg, msgexist){return host.GMSManager.RunMacro("wpanel", "Macros.TemplCatAdd", path, title, msg, msgexist);}
function vbTemplCatDel(path, cat, title, msg){return host.GMSManager.RunMacro("wpanel", "Macros.TemplCatDel", path, cat, title, msg);}
function vbTemplPath(path, title){return host.GMSManager.RunMacro("wpanel", "Macros.TemplPath", path, title);}
function vbTemplList(path, title, msg){
	ret = host.GMSManager.RunMacro("wpanel", "Macros.TemplList", path, title, msg);
	ret = (ret) ? ret.split(";") : [];
	return ret;
}
function vbTemplFiles(path){
	ret = host.GMSManager.RunMacro("wpanel", "Macros.TemplFiles", path);
	ret = (ret) ? ret.split(";") : [];
	return ret;
}

function vbWebcamGetImg(resX, resY){return host.GMSManager.RunMacro("wpanel", "webcam.WebcamGetImg", resX, resY);}
function vbWebcamCorrect(shape){return host.GMSManager.RunMacro("wpanel", "webcam.CorrectImg", shape);}
function vbWebcamSaveDis(mode){return host.GMSManager.RunMacro("wpanel", "webcam.CorrectDistortion", mode);}

/* To rewrite */
function curves_to_curve(){
	vbCurveToCurve(Shift());
}
function corners_off(){
	vbCornersOff(Shift());
}
function delete_overlap(){
	vbDeleteOverlap(Shift());
}


function vbCurveToCurve(mode){return host.GMSManager.RunMacro("wpanel", "Macros.curves_to_curve", mode);}
function vbCornersOff(){return host.GMSManager.RunMacro("wpanel", "Macros.corner_off");}
function vbDeleteOverlap(mode){return host.GMSManager.RunMacro("wpanel", "Macros.delete_overlap_make", mode);}


function getEOS(){
	if(defdoc()){
		var esr = host.ActiveSelectionRange;
		esr.RemoveAll();
		return esr;
	}else{
		return host.GMSManager.RunMacro("wpanel", "Macros.getOS");
	}
}

function clear_template(nedorez, OS, shft, undogroup){
	if(nedorez === undefined) nedorez = ch_razryv_nedorez.checked;	
	if(OS === undefined) OS = get_OS();
	if(shft === undefined) shft = Shift();	
	if(undogroup === undefined) undogroup = true;
		
	cnt_os = OS.Shapes.Count;
	var sr = host.ActiveSelectionRange;
	sr.RemoveAll();
	do_save(val_nest_qty);
	if(cnt_os>0){
		do_begin("make nest ",undogroup, glOptim);
		cont = OS.FirstShape;
		//OS.Sort("@shape1.width*@shape1.height > @shape2.width*@shape2.height");
		OS.Remove(1);
		for(var i=1;i<=cnt_os;i++){
			s = OS.Shapes(i);	
			//if(sr.Shapes.Count>0) sr.CreateSelection();
		}
		do_end(undogroup);
	}
	return sr;
}